[SCM] live-boot branch, debian, updated. debian/3.0_a28-1-10-ga89bf1d

Daniel Baumann daniel at debian.org
Tue Jun 5 14:13:54 UTC 2012


The following commit has been merged in the debian branch:
commit c48696a0ebe9ffc938b84b921db90ac620339a52
Author: Daniel Baumann <daniel at debian.org>
Date:   Tue Jun 5 14:46:19 2012 +0200

    Splitting out a first bunch of functions out to /live/live/boot/.

diff --git a/Makefile b/Makefile
index e2f6cde..655f41f 100644
--- a/Makefile
+++ b/Makefile
@@ -4,7 +4,7 @@ SHELL := sh -e
 
 LANGUAGES = $(shell cd manpages/po && ls)
 
-SCRIPTS = bin/* initramfs-tools/hooks/* initramfs-tools/scripts/live initramfs-tools/scripts/live-functions initramfs-tools/scripts/live-helpers initramfs-tools/scripts/*/* scripts/*
+SCRIPTS = bin/* initramfs-tools/hooks/* initramfs-tools/scripts/live initramfs-tools/scripts/live-functions initramfs-tools/scripts/live-helpers initramfs-tools/scripts/*/* scripts/*.sh scripts/*/*
 
 all: build
 
@@ -43,7 +43,7 @@ build:
 install:
 	# Installing scripts
 	mkdir -p $(DESTDIR)/lib/live
-	cp -r scripts/boot.sh $(DESTDIR)/lib/live
+	cp -r scripts/boot.sh scripts/boot $(DESTDIR)/lib/live
 
 	# Installing executables
 	mkdir -p $(DESTDIR)/sbin
diff --git a/initramfs-tools/hooks/live b/initramfs-tools/hooks/live
index 7113580..40f3de6 100755
--- a/initramfs-tools/hooks/live
+++ b/initramfs-tools/hooks/live
@@ -52,7 +52,7 @@ fi
 [ "${QUIET}" ] || echo -n " "core
 
 mkdir -p "${DESTDIR}/lib/live"
-cp -a /lib/live/boot.sh "${DESTDIR}/lib/live"
+cp -a /lib/live/boot.sh /lib/live/boot "${DESTDIR}/lib/live"
 
 # Configuration
 if [ -e /usr/share/live-boot/languagelist ]
diff --git a/initramfs-tools/scripts/live-helpers b/initramfs-tools/scripts/live-helpers
index 2fcf441..73d15e7 100644
--- a/initramfs-tools/scripts/live-helpers
+++ b/initramfs-tools/scripts/live-helpers
@@ -23,401 +23,6 @@ old_root_snapshot_label="live-sn"
 home_snapshot_label="home-sn"
 persistence_list="live-persistence.conf"
 
-Arguments ()
-{
-	PRESEEDS=""
-	LOCATIONS=""
-
-	for ARGUMENT in $(cat /proc/cmdline)
-	do
-		case "${ARGUMENT}" in
-			skipconfig)
-				NOACCESSIBILITY="Yes"
-				NOFASTBOOT="Yes"
-				NOFSTAB="Yes"
-				NONETWORKING="Yes"
-
-				export NOACCESSIBILITY NOFASTBOOT NOFSTAB NONETWORKING
-				;;
-
-			access=*)
-				ACCESS="${ARGUMENT#access=}"
-				export ACCESS
-				;;
-
-			console=*)
-				DEFCONSOLE="${ARGUMENT#*=}"
-				export DEFCONSOLE
-				;;
-
-			BOOTIF=*)
-				BOOTIF="${x#BOOTIF=}"
-				;;
-
-			debug)
-				DEBUG="Yes"
-				export DEBUG
-
-				set -x
-				;;
-
-			dhcp)
-				# Force dhcp even while netbooting
-				# Use for debugging in case somebody works on fixing dhclient
-				DHCP="Force";
-				export DHCP
-				;;
-
-			nodhcp)
-				unset DHCP
-				;;
-
-			ethdevice=*)
-				DEVICE="${ARGUMENT#ethdevice=}"
-				ETHDEVICE="${DEVICE}"
-				export DEVICE ETHDEVICE
-				;;
-
-			ethdevice-timeout=*)
-				ETHDEV_TIMEOUT="${ARGUMENT#ethdevice-timeout=}"
-				export ETHDEV_TIMEOUT
-				;;
-
-			fetch=*)
-				FETCH="${ARGUMENT#fetch=}"
-				export FETCH
-				;;
-
-			findiso=*)
-				FINDISO="${ARGUMENT#findiso=}"
-				export FINDISO
-				;;
-
-			forcepersistencefsck)
-				FORCEPERSISTENCEFSCK="Yes"
-				export FORCEPERSISTENCEFSCK
-				;;
-
-			ftpfs=*)
-				FTPFS="${ARGUMENT#ftpfs=}"
-				export FTPFS
-				;;
-
-			httpfs=*)
-				HTTPFS="${ARGUMENT#httpfs=}"
-				export HTTPFS
-				;;
-
-			iscsi=*)
-				ISCSI="${ARGUMENT#iscsi=}"
-				#ip:port - separated by ;
-				ISCSI_PORTAL="${ISCSI%;*}"
-				if echo "${ISCSI_PORTAL}" | grep -q , ; then
-					ISCSI_SERVER="${ISCSI_PORTAL%,*}"
-					ISCSI_PORT="${ISCSI_PORTAL#*,}"
-				fi
-				#target name
-				ISCSI_TARGET="${ISCSI#*;}"
-				export ISCSI ISCSI_PORTAL ISCSI_TARGET ISCSI_SERVER ISCSI_PORT
-				;;
-
-			isofrom=*|fromiso=*)
-				FROMISO="${ARGUMENT#*=}"
-				export FROMISO
-				;;
-
-			ignore_uuid)
-				IGNORE_UUID="Yes"
-				export IGNORE_UUID
-				;;
-
-			integrity-check)
-				INTEGRITY_CHECK="Yes"
-				export INTEGRITY_CHECK
-				;;
-
-			ip=*)
-				STATICIP="${ARGUMENT#ip=}"
-
-				if [ -z "${STATICIP}" ]
-				then
-					STATICIP="frommedia"
-				fi
-
-				export STATICIP
-				;;
-
-			live-getty)
-				LIVE_GETTY="1"
-				export LIVE_GETTY
-				;;
-
-			live-media=*|bootfrom=*)
-				LIVE_MEDIA="${ARGUMENT#*=}"
-				export LIVE_MEDIA
-				;;
-
-			live-media-encryption=*|encryption=*)
-				LIVE_MEDIA_ENCRYPTION="${ARGUMENT#*=}"
-				export LIVE_MEDIA_ENCRYPTION
-				;;
-
-			live-media-offset=*)
-				LIVE_MEDIA_OFFSET="${ARGUMENT#live-media-offset=}"
-				export LIVE_MEDIA_OFFSET
-				;;
-
-			live-media-path=*)
-				LIVE_MEDIA_PATH="${ARGUMENT#live-media-path=}"
-				export LIVE_MEDIA_PATH
-				;;
-
-			live-media-timeout=*)
-				LIVE_MEDIA_TIMEOUT="${ARGUMENT#live-media-timeout=}"
-				export LIVE_MEDIA_TIMEOUT
-				;;
-
-			module=*)
-				MODULE="${ARGUMENT#module=}"
-				export MODULE
-				;;
-
-			netboot=*)
-				NETBOOT="${ARGUMENT#netboot=}"
-				export NETBOOT
-				;;
-
-			nfsopts=*)
-				NFSOPTS="${ARGUMENT#nfsopts=}"
-				export NFSOPTS
-				;;
-
-			nfsoverlay=*)
-				NFS_COW="${ARGUMENT#nfsoverlay=}"
-				export NFS_COW
-				;;
-
-			noaccessibility)
-				NOACCESSIBILITY="Yes"
-				export NOACCESSIBILITY
-				;;
-
-			nofastboot)
-				NOFASTBOOT="Yes"
-				export NOFASTBOOT
-				;;
-
-			nofstab)
-				NOFSTAB="Yes"
-				export NOFSTAB
-				;;
-
-			nonetworking)
-				NONETWORKING="Yes"
-				export NONETWORKING
-				;;
-
-			ramdisk-size=*)
-				ramdisk_size="${ARGUMENT#ramdisk-size=}"
-				;;
-
-			swapon)
-				SWAPON="Yes"
-				export SWAPON
-				;;
-
-			persistence)
-				PERSISTENCE="Yes"
-				export PERSISTENCE
-				;;
-
-			persistence-encryption=*)
-				PERSISTENCE_ENCRYPTION="${ARGUMENT#*=}"
-				export PERSISTENCE_ENCRYPTION
-				;;
-
-			persistence-media=*)
-				PERSISTENCE_MEDIA="${ARGUMENT#*=}"
-				export PERSISTENCE_MEDIA
-				;;
-			persistence-method=*)
-				PERSISTENCE_METHOD="${ARGUMENT#*=}"
-				export PERSISTENCE_METHOD
-				;;
-
-			persistence-path=*)
-				PERSISTENCE_PATH="${ARGUMENT#persistence-path=}"
-				export PERSISTENCE_PATH
-				;;
-			persistence-read-only)
-				PERSISTENCE_READONLY="Yes"
-				export PERSISTENCE_READONLY
-				;;
-
-			persistence-storage=*)
-				PERSISTENCE_STORAGE="${ARGUMENT#persistence-storage=}"
-				export PERSISTENCE_STORAGE
-				;;
-
-			persistence-subtext=*)
-				old_root_overlay_label="${old_root_overlay_label}-${ARGUMENT#persistence-subtext=}"
-				old_home_overlay_label="${old_home_overlay_label}-${ARGUMENT#persistence-subtext=}"
-				custom_overlay_label="${custom_overlay_label}-${ARGUMENT#persistence-subtext=}"
-				root_snapshot_label="${root_snapshot_label}-${ARGUMENT#persistence-subtext=}"
-				old_root_snapshot_label="${root_snapshot_label}-${ARGUMENT#persistence-subtext=}"
-				home_snapshot_label="${home_snapshot_label}-${ARGUMENT#persistence-subtext=}"
-				;;
-
-			nopersistence)
-				NOPERSISTENCE="Yes"
-				export NOPERSISTENCE
-				;;
-
-			noprompt)
-				NOPROMPT="Yes"
-				export NOPROMPT
-				;;
-
-			noprompt=*)
-				NOPROMPT="${ARGUMENT#noprompt=}"
-				export NOPROMPT
-				;;
-
-			quickusbmodules)
-				QUICKUSBMODULES="Yes"
-				export QUICKUSBMODULES
-				;;
-
-			preseed/file=*|file=*)
-				LOCATIONS="${ARGUMENT#*=} ${LOCATIONS}"
-				export LOCATIONS
-				;;
-
-			nopreseed)
-				NOPRESEED="Yes"
-				export NOPRESEED
-				;;
-
-			*/*=*)
-				question="${ARGUMENT%%=*}"
-				value="${ARGUMENT#*=}"
-				PRESEEDS="${PRESEEDS}\"${question}=${value}\" "
-				export PRESEEDS
-				;;
-
-			showmounts)
-				SHOWMOUNTS="Yes"
-				export SHOWMOUNTS
-				;;
-
-			silent)
-				SILENT="Yes"
-				export SILENT
-				;;
-
-			todisk=*)
-				TODISK="${ARGUMENT#todisk=}"
-				export TODISK
-				;;
-
-			toram)
-				TORAM="Yes"
-				export TORAM
-				;;
-
-			toram=*)
-				TORAM="Yes"
-				MODULETORAM="${ARGUMENT#toram=}"
-				export TORAM MODULETORAM
-				;;
-
-			exposedroot)
-				EXPOSED_ROOT="Yes"
-				export EXPOSED_ROOT
-				;;
-
-			plainroot)
-				PLAIN_ROOT="Yes"
-				export PLAIN_ROOT
-				;;
-
-			skipunion)
-				SKIP_UNION_MOUNTS="Yes"
-				export SKIP_UNION_MOUNTS
-				;;
-
-			root=*)
-				ROOT="${ARGUMENT#root=}"
-				export ROOT
-				;;
-
-			union=*)
-				UNIONTYPE="${ARGUMENT#union=}"
-				export UNIONTYPE
-				;;
-		esac
-	done
-
-	# sort of compatibility with netboot.h from linux docs
-	if [ -z "${NETBOOT}" ]
-	then
-		if [ "${ROOT}" = "/dev/nfs" ]
-		then
-			NETBOOT="nfs"
-			export NETBOOT
-		elif [ "${ROOT}" = "/dev/cifs" ]
-		then
-			NETBOOT="cifs"
-			export NETBOOT
-		fi
-	fi
-
-	if [ -z "${MODULE}" ]
-	then
-		MODULE="filesystem"
-		export MODULE
-	fi
-
-	if [ -z "${UNIONTYPE}" ]
-	then
-		UNIONTYPE="aufs"
-		export UNIONTYPE
-	fi
-
-	if [ -z "${PERSISTENCE_ENCRYPTION}" ]
-	then
-		PERSISTENCE_ENCRYPTION="none"
-		export PERSISTENCE_ENCRYPTION
-	elif is_in_comma_sep_list luks ${PERSISTENCE_ENCRYPTION}
-	then
-		if ! modprobe dm-crypt
-		then
-			log_warning_msg "Unable to load module dm-crypt"
-			PERSISTENCE_ENCRYPTION=$(echo ${PERSISTENCE_ENCRYPTION} | sed -e 's/\<luks,\|,\?luks$//g')
-			export PERSISTENCE_ENCRYPTION
-		fi
-
-		if [ ! -x /lib/cryptsetup/askpass ] || [ ! -x /sbin/cryptsetup ]
-		then
-			log_warning_msg "cryptsetup in unavailable"
-			PERSISTENCE_ENCRYPTION=$(echo ${PERSISTENCE_ENCRYPTION} | sed -e 's/\<luks,\|,\?luks$//g')
-			export PERSISTENCE_ENCRYPTION
-		fi
-	fi
-
-	if [ -z "${PERSISTENCE_METHOD}" ]
-	then
-		PERSISTENCE_METHOD="snapshot,overlay"
-		export PERSISTENCE_METHOD
-	fi
-
-	if [ -z "${PERSISTENCE_STORAGE}" ]
-	then
-		PERSISTENCE_STORAGE="filesystem,file"
-		export PERSISTENCE_STORAGE
-	fi
-}
-
 is_in_list_separator_helper () {
 	local sep=${1}
 	shift
diff --git a/scripts/boot.sh b/scripts/boot.sh
index 83114a2..5d4a20d 100755
--- a/scripts/boot.sh
+++ b/scripts/boot.sh
@@ -2,6 +2,14 @@
 
 # set -e
 
+for _SCRIPT in /lib/live/boot/*
+do
+	if [ -e "${_SCRIPT}" ]
+	then
+		. ${_SCRIPT}
+	fi
+done
+
 export PATH="/root/usr/bin:/root/usr/sbin:/root/bin:/root/sbin:/usr/bin:/usr/sbin:/bin:/sbin"
 
 echo "/root/lib" >> /etc/ld.so.conf
@@ -158,1077 +166,6 @@ is_nice_device ()
 	return 1
 }
 
-copy_live_to ()
-{
-	copyfrom="${1}"
-	copytodev="${2}"
-	copyto="${copyfrom}_swap"
-
-	if [ -z "${MODULETORAM}" ]
-	then
-		size=$(fs_size "" ${copyfrom}/${LIVE_MEDIA_PATH} "used")
-	else
-		MODULETORAMFILE="${copyfrom}/${LIVE_MEDIA_PATH}/${MODULETORAM}"
-
-		if [ -f "${MODULETORAMFILE}" ]
-		then
-			size=$( expr $(ls -la ${MODULETORAMFILE} | awk '{print $5}') / 1024 + 5000 )
-		else
-			log_warning_msg "Error: toram-module ${MODULETORAM} (${MODULETORAMFILE}) could not be read."
-			return 1
-		fi
-	fi
-
-	if [ "${copytodev}" = "ram" ]
-	then
-		# copying to ram:
-		freespace=$(awk '/^MemFree:/{f=$2} /^Cached:/{c=$2} END{print f+c}' /proc/meminfo)
-		mount_options="-o size=${size}k"
-		free_string="memory"
-		fstype="tmpfs"
-		dev="/dev/shm"
-	else
-		# it should be a writable block device
-		if [ -b "${copytodev}" ]
-		then
-			dev="${copytodev}"
-			free_string="space"
-			fstype=$(get_fstype "${dev}")
-			freespace=$(fs_size "${dev}")
-		else
-			log_warning_msg "${copytodev} is not a block device."
-			return 1
-		fi
-	fi
-
-	if [ "${freespace}" -lt "${size}" ]
-	then
-		log_warning_msg "Not enough free ${free_string} (${freespace}k free, ${size}k needed) to copy live media in ${copytodev}."
-		return 1
-	fi
-
-	# Custom ramdisk size
-	if [ -z "${mount_options}" ] && [ -n "${ramdisk_size}" ]
-	then
-		# FIXME: should check for wrong values
-		mount_options="-o size=${ramdisk_size}"
-	fi
-
-	# begin copying (or uncompressing)
-	mkdir "${copyto}"
-	log_begin_msg "mount -t ${fstype} ${mount_options} ${dev} ${copyto}"
-	mount -t "${fstype}" ${mount_options} "${dev}" "${copyto}"
-
-	if [ "${extension}" = "tgz" ]
-	then
-		cd "${copyto}"
-		tar zxf "${copyfrom}/${LIVE_MEDIA_PATH}/$(basename ${FETCH})"
-		rm -f "${copyfrom}/${LIVE_MEDIA_PATH}/$(basename ${FETCH})"
-		mount -r -o move "${copyto}" "${rootmnt}"
-		cd "${OLDPWD}"
-	else
-		if [ -n "${MODULETORAMFILE}" ]
-		then
-			if [ -x /bin/rsync ]
-			then
-				echo " * Copying $MODULETORAMFILE to RAM" 1>/dev/console
-				rsync -a --progress ${MODULETORAMFILE} ${copyto} 1>/dev/console # copy only the filesystem module
-			else
-				cp ${MODULETORAMFILE} ${copyto} # copy only the filesystem module
-			fi
-		else
-			if [ -x /bin/rsync ]
-			then
-				echo " * Copying whole medium to RAM" 1>/dev/console
-				rsync -a --progress ${copyfrom}/* ${copyto} 1>/dev/console  # "cp -a" from busybox also copies hidden files
-			else
-				mkdir -p ${copyto}/${LIVE_MEDIA_PATH}
-				cp -a ${copyfrom}/${LIVE_MEDIA_PATH}/* ${copyto}/${LIVE_MEDIA_PATH}
-				if [ -e ${copyfrom}/${LIVE_MEDIA_PATH}/.disk ]
-				then
-					cp -a ${copyfrom}/${LIVE_MEDIA_PATH}/.disk ${copyto}
-				fi
-			fi
-		fi
-
-		umount ${copyfrom}
-		mount -r -o move ${copyto} ${copyfrom}
-	fi
-
-	rmdir ${copyto}
-	return 0
-}
-
-do_netsetup ()
-{
-	modprobe -q af_packet # For DHCP
-
-	udevadm trigger
-	udevadm settle
-
-	[ -n "$ETHDEV_TIMEOUT" ] || ETHDEV_TIMEOUT=15
-	echo "Using timeout of $ETHDEV_TIMEOUT seconds for network configuration."
-
-	if [ -z "${NETBOOT}" ] && [ -z "${FETCH}" ] && \
-	   [ -z "${HTTPFS}" ] && [ -z "${FTPFS}" ]
-	then
-
-
-	# support for Syslinux IPAPPEND parameter
-	# it sets the BOOTIF variable on the kernel parameter
-
-	if [ -n "${BOOTIF}" ]
-	then
-		# pxelinux sets BOOTIF to a value based on the mac address of the
-		# network card used to PXE boot, so use this value for DEVICE rather
-		# than a hard-coded device name from initramfs.conf. this facilitates
-		# network booting when machines may have multiple network cards.
-		# pxelinux sets BOOTIF to 01-$mac_address
-
-		# strip off the leading "01-", which isn't part of the mac
-		# address
-		temp_mac=${BOOTIF#*-}
-
-		# convert to typical mac address format by replacing "-" with ":"
-		bootif_mac=""
-		IFS='-'
-		for x in $temp_mac
-		do
-			if [ -z "$bootif_mac" ]
-			then
-				bootif_mac="$x"
-			else
-				bootif_mac="$bootif_mac:$x"
-			fi
-		done
-		unset IFS
-
-		# look for devices with matching mac address, and set DEVICE to
-		# appropriate value if match is found.
-
-		for device in /sys/class/net/*
-		do
-			if [ -f "$device/address" ]
-			then
-				current_mac=$(cat "$device/address")
-
-				if [ "$bootif_mac" = "$current_mac" ]
-				then
-					DEVICE=${device##*/}
-					break
-				fi
-			fi
-		done
-	fi
-
-	# if ethdevice was not specified on the kernel command line
-	# make sure we try to get a working network configuration
-	# for *every* present network device (except for loopback of course)
-	if [ -z "$ETHDEVICE" ] ; then
-		echo "If you want to boot from a specific device use bootoption ethdevice=..."
-		for device in /sys/class/net/*; do
-			dev=${device##*/} ;
-			if [ "$dev" != "lo" ] ; then
-				ETHDEVICE="$ETHDEVICE $dev"
-			fi
-		done
-	fi
-
-	# split args of ethdevice=eth0,eth1 into "eth0 eth1"
-	for device in $(echo $ETHDEVICE | sed 's/,/ /g') ; do
-		devlist="$devlist $device"
-	done
-
-	# this is tricky (and ugly) because ipconfig sometimes just hangs/runs into
-	# an endless loop; if execution fails give it two further tries, that's
-	# why we use '$devlist $devlist $devlist' for the other for loop
-	for dev in $devlist $devlist $devlist ; do
-		echo "Executing ipconfig -t $ETHDEV_TIMEOUT $dev"
-		ipconfig -t "$ETHDEV_TIMEOUT" $dev | tee -a /netboot.config &
-		jobid=$!
-		sleep "$ETHDEV_TIMEOUT" ; sleep 1
-		if [ -r /proc/"$jobid"/status ] ; then
-			echo "Killing job $jobid for device $dev as ipconfig ran into recursion..."
-			kill -9 $jobid
-		fi
-
-		# if configuration of device worked we should have an assigned
-		# IP address, if so let's use the device as $DEVICE for later usage.
-		# simple and primitive approach which seems to work fine
-		if ifconfig $dev | grep -q 'inet.*addr:' ; then
-			export DEVICE="$dev"
-			break
-		fi
-	done
-
-	else
-		for interface in ${DEVICE}; do
-			ipconfig -t "$ETHDEV_TIMEOUT" ${interface} | tee /netboot-${interface}.config
-			[ -e /tmp/net-${interface}.conf ] && . /tmp/net-${interface}.conf
-			if [ "$IPV4ADDR" != "0.0.0.0" ]
-			then
-				break
-			fi
-		done
-	fi
-
-	for interface in ${DEVICE}; do
-		# source relevant ipconfig output
-		OLDHOSTNAME=${HOSTNAME}
-		[ -e /tmp/net-${interface}.conf ] && . /tmp/net-${interface}.conf
-		[ -z ${HOSTNAME} ] && HOSTNAME=${OLDHOSTNAME}
-		export HOSTNAME
-
-		if [ -n "${interface}" ]
-		then
-			HWADDR="$(cat /sys/class/net/${interface}/address)"
-		fi
-
-		if [ ! -e "/etc/resolv.conf" ]
-		then
-			echo "Creating /etc/resolv.conf"
-
-			if [ -n "${DNSDOMAIN}" ]
-			then
-				echo "domain ${DNSDOMAIN}" > /etc/resolv.conf
-				echo "search ${DNSDOMAIN}" >> /etc/resolv.conf
-			fi
-
-			for i in ${IPV4DNS0} ${IPV4DNS1} ${IPV4DNS1}
-			do
-				if [ -n "$i" ] && [ "$i" != 0.0.0.0 ]
-				then
-					echo "nameserver $i" >> /etc/resolv.conf
-				fi
-			done
-		fi
-
-		# Check if we have a network device at all
-		if ! ls /sys/class/net/"$interface" > /dev/null 2>&1 && \
-		   ! ls /sys/class/net/eth0 > /dev/null 2>&1 && \
-		   ! ls /sys/class/net/wlan0 > /dev/null 2>&1 && \
-		   ! ls /sys/class/net/ath0 > /dev/null 2>&1 && \
-		   ! ls /sys/class/net/ra0 > /dev/null 2>&1
-		then
-			panic "No supported network device found, maybe a non-mainline driver is required."
-		fi
-	done
-}
-
-do_netmount()
-{
-	do_netsetup
-
-	if [ "${NFSROOT}" = "auto" ]
-	then
-		NFSROOT=${ROOTSERVER}:${ROOTPATH}
-	fi
-
-	rc=1
-
-	if ( [ -n "${FETCH}" ] || [ -n "${HTTPFS}" ] || [ -n "${FTPFS}" ] )
-	then
-		do_httpmount
-		return $?
-	fi
-
-	if [ "${NFSROOT#*:}" = "${NFSROOT}" ] && [ "$NETBOOT" != "cifs" ]
-	then
-		NFSROOT=${ROOTSERVER}:${NFSROOT}
-	fi
-
-	log_begin_msg "Trying netboot from ${NFSROOT}"
-
-	if [ "${NETBOOT}" != "nfs" ] && do_cifsmount
-	then
-		rc=0
-	elif do_nfsmount
-	then
-		NETBOOT="nfs"
-		export NETBOOT
-		rc=0
-	fi
-
-	log_end_msg
-	return ${rc}
-}
-
-do_iscsi()
-{
-	do_netsetup
-	#modprobe ib_iser
-	modprobe iscsi_tcp
-	local debugopt=""
-	[ "${DEBUG}" = "Yes" ] && debugopt="-d 8"
-	#FIXME this name is supposed to be unique - some date + ifconfig hash?
-	ISCSI_INITIATORNAME="iqn.1993-08.org.debian.live:01:$(echo "${HWADDR}" | sed -e s/://g)"
-	export ISCSI_INITIATORNAME
-	if [ -n "${ISCSI_SERVER}" ] ; then
-		iscsistart $debugopt -i "${ISCSI_INITIATORNAME}" -t "${ISCSI_TARGET}" -g 1 -a "${ISCSI_SERVER}" -p "${ISCSI_PORT}"
-	else
-		iscsistart $debugopt -i "${ISCSI_INITIATORNAME}" -t "${ISCSI_TARGET}" -g 1 -a "${ISCSI_PORTAL}" -p 3260
-	fi
-	if [ $? != 0 ]
-	then
-		panic "Failed to log into iscsi target"
-	fi
-	local host="$(ls -d /sys/class/scsi_host/host*/device/iscsi_host:host* \
-			    /sys/class/scsi_host/host*/device/iscsi_host/host* | sed -e 's:/device.*::' -e 's:.*host::')"
-	if [ -n "${host}" ]
-	then
-		local devices=""
-		local i=0
-		while [ -z "${devices}" -a $i -lt 60 ]
-		do
-			sleep 1
-			devices="$(ls -d /sys/class/scsi_device/${host}*/device/block:* \
-					 /sys/class/scsi_device/${host}*/device/block/* | sed -e 's!.*[:/]!!')"
-			i=$(expr $i + 1)
-			echo -ne $i\\r
-		done
-		for dev in $devices
-		do
-			if check_dev "null" "/dev/$dev"
-			then
-				NETBOOT="iscsi"
-				export NETBOOT
-				return 0;
-			fi
-		done
-		panic "Failed to locate a live device on iSCSI devices (tried: $devices)."
-	else
-		panic "Failed to locate iSCSI host in /sys"
-	fi
-}
-
-do_httpmount ()
-{
-	rc=1
-
-	for webfile in HTTPFS FTPFS FETCH
-	do
-		local url="$(eval echo \"\$\{${webfile}\}\")"
-		local extension="$(echo "${url}" | sed 's/\(.*\)\.\(.*\)/\2/')"
-
-		if [ -n "$url" ]
-		then
-			case "${extension}" in
-				iso|squashfs|tgz|tar)
-					if [ "${extension}" = "iso" ]
-					then
-						mkdir -p "${alt_mountpoint}"
-						dest="${alt_mountpoint}"
-					else
-						local dest="${mountpoint}/${LIVE_MEDIA_PATH}"
-						mount -t ramfs ram "${mountpoint}"
-						mkdir -p "${dest}"
-					fi
-					if [ "${webfile}" = "FETCH" ]
-					then
-						case "$url" in
-							tftp*)
-								ip="$(dirname $url | sed -e 's|tftp://||g' -e 's|/.*$||g')"
-								rfile="$(echo $url | sed -e "s|tftp://$ip||g")"
-								lfile="$(basename $url)"
-								log_begin_msg "Trying tftp -g -b 10240 -r $rfile -l ${dest}/$lfile $ip"
-								tftp -g -b 10240 -r $rfile -l ${dest}/$lfile $ip
-							;;
-
-							*)
-								log_begin_msg "Trying wget ${url} -O ${dest}/$(basename ${url})"
-								wget "${url}" -O "${dest}/$(basename ${url})"
-								;;
-						esac
-					else
-						log_begin_msg "Trying to mount ${url} on ${dest}/$(basename ${url})"
-						if [ "${webfile}" = "FTPFS" ]
-						then
-							FUSE_MOUNT="curlftpfs"
-							url="$(dirname ${url})"
-						else
-							FUSE_MOUNT="httpfs"
-						fi
-						modprobe fuse
-						$FUSE_MOUNT "${url}" "${dest}"
-						ROOT_PID="$(minips h -C "$FUSE_MOUNT" | { read x y ; echo "$x" ; } )"
-					fi
-					[ ${?} -eq 0 ] && rc=0
-					[ "${extension}" = "tgz" ] && live_dest="ram"
-					if [ "${extension}" = "iso" ]
-					then
-						isoloop=$(setup_loop "${dest}/$(basename "${url}")" "loop" "/sys/block/loop*" "" '')
-						mount -t iso9660 "${isoloop}" "${mountpoint}"
-						rc=${?}
-					fi
-					break
-					;;
-
-				*)
-					log_begin_msg "Unrecognized archive extension for ${url}"
-					;;
-			esac
-		fi
-	done
-
-	if [ ${rc} != 0 ]
-	then
-		if [ -d "${alt_mountpoint}" ]
-		then
-		        umount "${alt_mountpoint}"
-			rmdir "${alt_mountpoint}"
-		fi
-		umount "${mountpoint}"
-	elif [ "${webfile}"  != "FETCH" ] ; then
-		NETBOOT="${webfile}"
-		export NETBOOT
-	fi
-
-	return ${rc}
-}
-
-do_nfsmount ()
-{
-	rc=1
-
-	modprobe -q nfs
-
-	if [ -n "${NFSOPTS}" ]
-	then
-		NFSOPTS="-o ${NFSOPTS}"
-	fi
-
-	log_begin_msg "Trying nfsmount -o nolock -o ro ${NFSOPTS} ${NFSROOT} ${mountpoint}"
-
-	# FIXME: This while loop is an ugly HACK round an nfs bug
-	i=0
-	while [ "$i" -lt 60 ]
-	do
-		nfsmount -o nolock -o ro ${NFSOPTS} "${NFSROOT}" "${mountpoint}" && rc=0 && break
-		sleep 1
-		i="$(($i + 1))"
-	done
-
-	return ${rc}
-}
-
-do_cifsmount ()
-{
-	rc=1
-
-	if [ -x "/sbin/mount.cifs" ]
-	then
-		if [ -z "${NFSOPTS}" ]
-		then
-			CIFSOPTS="-ouser=root,password="
-		else
-			CIFSOPTS="-o ${NFSOPTS}"
-		fi
-
-		log_begin_msg "Trying mount.cifs ${NFSROOT} ${mountpoint} ${CIFSOPTS}"
-		modprobe -q cifs
-
-		if mount.cifs "${NFSROOT}" "${mountpoint}" "${CIFSOPTS}"
-		then
-			rc=0
-		fi
-	fi
-
-	return ${rc}
-}
-
-do_snap_copy ()
-{
-	fromdev="${1}"
-	todir="${2}"
-	snap_type="${3}"
-	size=$(fs_size "${fromdev}" "" "used")
-
-	if [ -b "${fromdev}" ]
-	then
-		log_success_msg "Copying snapshot ${fromdev} to ${todir}..."
-
-		# look for free mem
-		if [ -n "${HOMEMOUNTED}" -a "${snap_type}" = "HOME" ]
-		then
-			todev=$(awk -v pat="$(base_path ${todir})" '$2 == pat { print $1 }' /proc/mounts)
-			freespace=$(df -k | awk '/'${todev}'/{print $4}')
-		else
-			freespace=$(awk '/^MemFree:/{f=$2} /^Cached:/{c=$2} END{print f+c}' /proc/meminfo)
-		fi
-
-		tomount="/mnt/tmpsnap"
-
-		if [ ! -d "${tomount}" ]
-		then
-			mkdir -p "${tomount}"
-		fi
-
-		fstype=$(get_fstype "${fromdev}")
-
-		if [ -n "${fstype}" ]
-		then
-			# Copying stuff...
-			mount -o ro -t "${fstype}" "${fromdev}" "${tomount}" || log_warning_msg "Error in mount -t ${fstype} -o ro ${fromdev} ${tomount}"
-			cp -a "${tomount}"/* ${todir}
-			umount "${tomount}"
-		else
-			log_warning_msg "Unrecognized fstype: ${fstype} on ${fromdev}:${snap_type}"
-		fi
-
-		rmdir "${tomount}"
-
-		if echo ${fromdev} | grep -qs loop
-		then
-			losetup -d "${fromdev}"
-		fi
-
-		return 0
-	else
-		log_warning_msg "Unable to find the snapshot ${snap_type} medium"
-		return 1
-	fi
-}
-
-try_snap ()
-{
-	# copy the contents of previously found snapshot to ${snap_mount}
-	# and remember the device and filename for resync on exit in live-boot.init
-
-	snapdata="${1}"
-	snap_mount="${2}"
-	snap_type="${3}"
-	snap_relpath="${4}"
-
-	if [ -z "${snap_relpath}" ]
-	then
-		# root snapshot, default usage
-		snap_relpath="/"
-	else
-		# relative snapshot (actually used just for "/home" snapshots)
-		snap_mount="${2}${snap_relpath}"
-	fi
-
-	if [ -n "${snapdata}" ] && [ ! -b "${snapdata}" ]
-	then
-		log_success_msg "found snapshot: ${snapdata}"
-		snapdev="$(echo ${snapdata} | cut -f1 -d ' ')"
-		snapback="$(echo ${snapdata} | cut -f2 -d ' ')"
-		snapfile="$(echo ${snapdata} | cut -f3 -d ' ')"
-
-		if ! try_mount "${snapdev}" "${snapback}" "ro"
-		then
-			break
-		fi
-
-		RES="0"
-
-		if echo "${snapfile}" | grep -qs '\(squashfs\|ext2\|ext3\|ext4\|jffs2\)'
-		then
-			# squashfs, jffs2 or ext2/ext3/ext4 snapshot
-			dev=$(get_backing_device "${snapback}/${snapfile}")
-
-			do_snap_copy "${dev}" "${snap_mount}" "${snap_type}"
-			RES="$?"
-		else
-			# cpio.gz snapshot
-
-			# Unfortunately klibc's cpio is incompatible with the
-			# rest of the world; everything else requires -u -d,
-			# while klibc doesn't implement them. Try to detect
-			# whether it's in use.
-			cpiopath="$(which cpio)" || true
-			if [ "$cpiopath" ] && grep -aq /lib/klibc "$cpiopath"
-			then
-				cpioargs=
-			else
-				cpioargs='--unconditional --make-directories'
-			fi
-
-			if [ -s "${snapback}/${snapfile}" ]
-			then
-				BEFOREDIR="$(pwd)"
-				cd "${snap_mount}" && zcat "${snapback}/${snapfile}" | $cpiopath $cpioargs --extract --preserve-modification-time --no-absolute-filenames --sparse 2>/dev/null
-				RES="$?"
-				cd "${BEFOREDIR}"
-			else
-				log_warning_msg "${snapback}/${snapfile} is empty, adding it for sync on reboot."
-				RES="0"
-			fi
-
-			if [ "${RES}" != "0" ]
-			then
-				log_warning_msg "failure to \"zcat ${snapback}/${snapfile} | $cpiopath $cpioargs --extract --preserve-modification-time --no-absolute-filenames --sparse\""
-			fi
-		fi
-
-		umount "${snapback}" ||  log_warning_msg "failure to \"umount ${snapback}\""
-
-		if [ "${RES}" != "0" ]
-		then
-			log_warning_msg "Impossible to include the ${snapfile} Snapshot file"
-		fi
-
-	elif [ -b "${snapdata}" ]
-	then
-		# Try to find if it could be a snapshot partition
-		dev="${snapdata}"
-		log_success_msg "found snapshot ${snap_type} device on ${dev}"
-		if echo "${dev}" | grep -qs loop
-		then
-			# strange things happens, user confused?
-			snaploop=$( losetup ${dev} | awk '{print $3}' | tr -d '()' )
-			snapfile=$(basename ${snaploop})
-			snapdev=$(awk -v pat="$( dirname ${snaploop})" '$2 == pat { print $1 }' /proc/mounts)
-		else
-			snapdev="${dev}"
-		fi
-
-		if ! do_snap_copy "${dev}" "${snap_mount}" "${snap_type}"
-		then
-			log_warning_msg "Impossible to include the ${snap_type} Snapshot (i)"
-			return 1
-		else
-			if [ -n "${snapfile}" ]
-			then
-				# it was a loop device, user confused
-				umount ${snapdev}
-			fi
-		fi
-	else
-		log_warning_msg "Impossible to include the ${snap_type} Snapshot (o)"
-		return 1
-	fi
-
-	if [ -z ${PERSISTENCE_READONLY} ]
-	then
-		echo "export ${snap_type}SNAP=${snap_relpath}:${snapdev}:${snapfile}" >> snapshot.conf # for resync on reboot/halt
-	fi
-	return 0
-}
-
-setup_unionfs ()
-{
-	image_directory="${1}"
-	rootmnt="${2}"
-	addimage_directory="${3}"
-
-	case ${UNIONTYPE} in
-		aufs|unionfs|overlayfs)
-			modprobe -q -b ${UNIONTYPE}
-
-			if ! cut -f2 /proc/filesystems | grep -q "^${UNIONTYPE}\$" && [ -x /bin/unionfs-fuse ]
-			then
-				echo "${UNIONTYPE} not available, falling back to unionfs-fuse."
-				echo "This might be really slow."
-
-				UNIONTYPE="unionfs-fuse"
-			fi
-			;;
-	esac
-
-	if [ "${UNIONTYPE}" = unionfs-fuse ]
-	then
-		modprobe fuse
-	fi
-
-	# run-init can't deal with images in a subdir, but we're going to
-	# move all of these away before it runs anyway.  No, we're not,
-	# put them in / since move-mounting them into / breaks mono and
-	# some other apps.
-
-	croot="/"
-
-	# Let's just mount the read-only file systems first
-	rofslist=""
-
-	if [ -z "${PLAIN_ROOT}" ]
-	then
-		# Read image names from ${MODULE}.module if it exists
-		if [ -e "${image_directory}/filesystem.${MODULE}.module" ]
-		then
-			for IMAGE in $(cat ${image_directory}/filesystem.${MODULE}.module)
-			do
-				image_string="${image_string} ${image_directory}/${IMAGE}"
-			done
-		elif [ -e "${image_directory}/${MODULE}.module" ]
-		then
-			for IMAGE in $(cat ${image_directory}/${MODULE}.module)
-			do
-				image_string="${image_string} ${image_directory}/${IMAGE}"
-			done
-		else
-			# ${MODULE}.module does not exist, create a list of images
-			for FILESYSTEM in squashfs ext2 ext3 ext4 xfs jffs2 dir
-			do
-				for IMAGE in "${image_directory}"/*."${FILESYSTEM}"
-				do
-					if [ -e "${IMAGE}" ]
-					then
-						image_string="${image_string} ${IMAGE}"
-					fi
-				done
-			done
-
-			if [ -n "${addimage_directory}" ] && [ -d "${addimage_directory}" ]
-			then
-				for FILESYSTEM in squashfs ext2 ext3 ext4 xfs jffs2 dir
-				do
-					for IMAGE in "${addimage_directory}"/*."${FILESYSTEM}"
-					do
-						if [ -e "${IMAGE}" ]
-						then
-							image_string="${image_string} ${IMAGE}"
-						fi
-					done
-				done
-			fi
-
-			# Now sort the list
-			image_string="$(echo ${image_string} | sed -e 's/ /\n/g' | sort )"
-		fi
-
-		[ -n "${MODULETORAMFILE}" ] && image_string="${image_directory}/$(basename ${MODULETORAMFILE})"
-
-		mkdir -p "${croot}"
-
-		for image in ${image_string}
-		do
-			imagename=$(basename "${image}")
-
-			export image devname
-			maybe_break live-realpremount
-			log_begin_msg "Running /scripts/live-realpremount"
-			run_scripts /scripts/live-realpremount
-			log_end_msg
-
-			if [ -d "${image}" ]
-			then
-				# it is a plain directory: do nothing
-				rofslist="${image} ${rofslist}"
-			elif [ -f "${image}" ]
-			then
-				if losetup --help 2>&1 | grep -q -- "-r\b"
-				then
-					backdev=$(get_backing_device "${image}" "-r")
-				else
-					backdev=$(get_backing_device "${image}")
-				fi
-				fstype=$(get_fstype "${backdev}")
-
-				if [ "${fstype}" = "unknown" ]
-				then
-					panic "Unknown file system type on ${backdev} (${image})"
-				fi
-
-				if [ -z "${fstype}" ]
-				then
-					fstype="${imagename##*.}"
-					log_warning_msg "Unknown file system type on ${backdev} (${image}), assuming ${fstype}."
-				fi
-
-				if [ "${UNIONTYPE}" != "unionmount" ]
-				then
-					mpoint="${croot}/${imagename}"
-					rofslist="${mpoint} ${rofslist}"
-				else
-					mpoint="${rootmnt}"
-					rofslist="${rootmnt} ${rofslist}"
-				fi
-				mkdir -p "${mpoint}"
-				log_begin_msg "Mounting \"${image}\" on \"${mpoint}\" via \"${backdev}\""
-				mount -t "${fstype}" -o ro,noatime "${backdev}" "${mpoint}" || panic "Can not mount ${backdev} (${image}) on ${mpoint}"
-				log_end_msg
-			fi
-		done
-	else
-		# we have a plain root system
-		mkdir -p "${croot}/filesystem"
-		log_begin_msg "Mounting \"${image_directory}\" on \"${croot}/filesystem\""
-		mount -t $(get_fstype "${image_directory}") -o ro,noatime "${image_directory}" "${croot}/filesystem" || \
-			panic "Can not mount ${image_directory} on ${croot}/filesystem" && \
-			rofslist="${croot}/filesystem ${rofslist}"
-		# probably broken:
-		mount -o bind ${croot}/filesystem $mountpoint
-		log_end_msg
-	fi
-
-	# tmpfs file systems
-	touch /etc/fstab
-	mkdir -p /live
-	mount -t tmpfs tmpfs /live
-	mkdir -p /live/overlay
-
-	# Looking for persistence devices or files
-	if [ -n "${PERSISTENCE}" ] && [ -z "${NOPERSISTENCE}" ]
-	then
-
-		if [ -z "${QUICKUSBMODULES}" ]
-		then
-			# Load USB modules
-			num_block=$(ls -l /sys/block | wc -l)
-			for module in sd_mod uhci-hcd ehci-hcd ohci-hcd usb-storage
-			do
-				modprobe -q -b ${module}
-			done
-
-			udevadm trigger
-			udevadm settle
-
-			# For some reason, udevsettle does not block in this scenario,
-			# so we sleep for a little while.
-			#
-			# See https://bugs.launchpad.net/ubuntu/+source/casper/+bug/84591
-			for timeout in 5 4 3 2 1
-			do
-				sleep 1
-
-				if [ $(ls -l /sys/block | wc -l) -gt ${num_block} ]
-				then
-					break
-				fi
-			done
-		fi
-
-		case "${PERSISTENCE_MEDIA}" in
-			removable)
-				whitelistdev="$(removable_dev)"
-				;;
-			removable-usb)
-				whitelistdev="$(removable_usb_dev)"
-				;;
-			*)
-				whitelistdev=""
-				;;
-		esac
-
-		if is_in_comma_sep_list overlay ${PERSISTENCE_METHOD}
-		then
-			overlays="${old_root_overlay_label} ${old_home_overlay_label} ${custom_overlay_label}"
-		fi
-
-		if is_in_comma_sep_list snapshot ${PERSISTENCE_METHOD}
-		then
-			snapshots="${root_snapshot_label} ${home_snapshot_label}"
-		fi
-
-		local root_snapdata=""
-		local home_snapdata=""
-		local overlay_devices=""
-		for media in $(find_persistence_media "${overlays}" "${snapshots}" "${whitelistdev}")
-		do
-			media="$(echo ${media} | tr ":" " ")"
-			case ${media} in
-				${root_snapshot_label}=*|${old_root_snapshot_label}=*)
-					if [ -z "${root_snapdata}" ]
-					then
-						root_snapdata="${media#*=}"
-					fi
-					;;
-				${home_snapshot_label}=*)
-					# This second type should be removed when snapshot will get smarter,
-					# hence when "/etc/live-snapshot*list" will be supported also by
-					# ext2|ext3|ext4|jffs2 snapshot types.
-					if [ -z "${home_snapdata}" ]
-					then
-						home_snapdata="${media#*=}"
-					fi
-					;;
-				${old_root_overlay_label}=*)
-					device="${media#*=}"
-					fix_backwards_compatibility ${device} / union
-					overlay_devices="${overlay_devices} ${device}"
-					;;
-				${old_home_overlay_label}=*)
-					device="${media#*=}"
-					fix_backwards_compatibility ${device} /home bind
-					overlay_devices="${overlay_devices} ${device}"
-					;;
-				${custom_overlay_label}=*)
-					device="${media#*=}"
-					overlay_devices="${overlay_devices} ${device}"
-					;;
-			 esac
-		done
-	elif [ -n "${NFS_COW}" ] && [ -z "${NOPERSISTENCE}" ]
-	then
-		# check if there are any nfs options
-		if echo ${NFS_COW}|grep -q ','
-		then
-			nfs_cow_opts="-o nolock,$(echo ${NFS_COW}|cut -d, -f2-)"
-			nfs_cow=$(echo ${NFS_COW}|cut -d, -f1)
-		else
-			nfs_cow_opts="-o nolock"
-			nfs_cow=${NFS_COW}
-		fi
-
-		if [ -n "${PERSISTENCE_READONLY}" ]
-		then
-			nfs_cow_opts="${nfs_cow_opts},nocto,ro"
-		fi
-
-		mac="$(get_mac)"
-		if [ -n "${mac}" ]
-		then
-			cowdevice=$(echo ${nfs_cow}|sed "s/client_mac_address/${mac}/")
-			cow_fstype="nfs"
-		else
-			panic "unable to determine mac address"
-		fi
-	fi
-
-	if [ -z "${cowdevice}" ]
-	then
-		cowdevice="tmpfs"
-		cow_fstype="tmpfs"
-		cow_mountopt="rw,noatime,mode=755"
-	fi
-
-	if [ "${UNIONTYPE}" != "unionmount" ]
-	then
-		if [ -n "${PERSISTENCE_READONLY}" ] && [ "${cowdevice}" != "tmpfs" ]
-		then
-			mount -t tmpfs -o rw,noatime,mode=755 tmpfs "/live/overlay"
-			root_backing="/live/persistence/$(basename ${cowdevice})-root"
-			mkdir -p ${root_backing}
-		else
-			root_backing="/live/overlay"
-		fi
-
-		if [ "${cow_fstype}" = "nfs" ]
-		then
-			log_begin_msg \
-				"Trying nfsmount ${nfs_cow_opts} ${cowdevice} ${root_backing}"
-			nfsmount ${nfs_cow_opts} ${cowdevice} ${root_backing} || \
-				panic "Can not mount ${cowdevice} (n: ${cow_fstype}) on ${root_backing}"
-		else
-			mount -t ${cow_fstype} -o ${cow_mountopt} ${cowdevice} ${root_backing} || \
-				panic "Can not mount ${cowdevice} (o: ${cow_fstype}) on ${root_backing}"
-		fi
-	fi
-
-	rofscount=$(echo ${rofslist} |wc -w)
-
-	rofs=${rofslist%% }
-
-	if [ -n "${EXPOSED_ROOT}" ]
-	then
-		if [ ${rofscount} -ne 1 ]
-		then
-			panic "only one RO file system supported with exposedroot: ${rofslist}"
-		fi
-
-		mount --bind ${rofs} ${rootmnt} || \
-			panic "bind mount of ${rofs} failed"
-
-		if [ -z "${SKIP_UNION_MOUNTS}" ]
-		then
-			cow_dirs='/var/tmp /var/lock /var/run /var/log /var/spool /home /var/lib/live'
-		else
-			cow_dirs=''
-		fi
-	else
-		cow_dirs="/"
-	fi
-
-	if [ "${cow_fstype}" != "tmpfs" ] && [ "${cow_dirs}" != "/" ] && [ "${UNIONTYPE}" = "unionmount" ]
-	then
-		true # FIXME: Maybe it does, I don't really know.
-		#panic "unionmount does not support subunions (${cow_dirs})."
-	fi
-
-	for dir in ${cow_dirs}; do
-		unionmountpoint="${rootmnt}${dir}"
-		mkdir -p ${unionmountpoint}
-		if [ "${UNIONTYPE}" = "unionmount" ]
-		then
-			# FIXME: handle PERSISTENCE_READONLY
-			unionmountopts="-t ${cow_fstype} -o noatime,union,${cow_mountopt} ${cowdevice}"
-			mount_full $unionmountopts "${unionmountpoint}"
-		else
-			cow_dir="/live/overlay${dir}"
-			rofs_dir="${rofs}${dir}"
-			mkdir -p ${cow_dir}
-			if [ -n "${PERSISTENCE_READONLY}" ] && [ "${cowdevice}" != "tmpfs" ]
-			then
-				do_union ${unionmountpoint} ${cow_dir} ${root_backing} ${rofs_dir}
-			else
-				do_union ${unionmountpoint} ${cow_dir} ${rofs_dir}
-			fi
-		fi || panic "mount ${UNIONTYPE} on ${unionmountpoint} failed with option ${unionmountopts}"
-	done
-
-	# Correct the permissions of /:
-	chmod 0755 "${rootmnt}"
-
-	live_rofs_list=""
-	# SHOWMOUNTS is necessary for custom mounts with the union option
-	# Since we may want to do custom mounts in user-space it's best to always enable SHOWMOUNTS
-	if true #[ -n "${SHOWMOUNTS}" ] || ( [ -n "${PERSISTENCE}" ] && [ -z "${NOPERSISTENCE}" ] 1)
-	then
-		# XXX: is the for loop really necessary? rofslist can only contain one item (see above XXX about EXPOSEDROOT) and this is also assumed elsewhere above (see use of $rofs above).
-		for d in ${rofslist}
-		do
-			live_rofs="/live/rofs/${d##*/}"
-			live_rofs_list="${live_rofs_list} ${live_rofs}"
-			mkdir -p "${live_rofs}"
-			case d in
-				*.dir)
-					# do nothing # mount -o bind "${d}" "${live_rofs}"
-					;;
-				*)
-					case "${UNIONTYPE}" in
-						unionfs-fuse)
-							mount -o bind "${d}" "${live_rofs}"
-							;;
-						*)
-							mount -o move "${d}" "${live_rofs}"
-							;;
-					esac
-					;;
-			esac
-		done
-	fi
-
-	# Adding custom persistence
-	if [ -n "${PERSISTENCE}" ] && [ -z "${NOPERSISTENCE}" ]
-	then
-		local custom_mounts="/tmp/custom_mounts.list"
-		rm -rf ${custom_mounts} 2> /dev/null
-
-		# Gather information about custom mounts from devies detected as overlays
-		get_custom_mounts ${custom_mounts} ${overlay_devices}
-
-		[ -n "${DEBUG}" ] && cp ${custom_mounts} "/live/persistence"
-
-		# Now we do the actual mounting (and symlinking)
-		local used_overlays=""
-		used_overlays=$(activate_custom_mounts ${custom_mounts})
-		rm ${custom_mounts}
-
-		# Close unused overlays (e.g. due to missing $persistence_list)
-		for overlay in ${overlay_devices}
-		do
-			if echo ${used_overlays} | grep -qve "^\(.* \)\?${device}\( .*\)\?$"
-			then
-				close_persistence_media ${overlay}
-			fi
-		done
-
-		# Look for other snapshots to copy in
-		[ -n "${root_snapdata}" ] && try_snap "${root_snapdata}" "${rootmnt}" "ROOT"
-		# This second type should be removed when snapshot grow smarter
-		[ -n "${home_snapdata}" ] && try_snap "${home_snapdata}" "${rootmnt}" "HOME" "/home"
-	fi
-
-	mkdir -p "${rootmnt}/live"
-	mount -o move /live "${rootmnt}/live" >/dev/null 2>&1 || mount -o bind /live "${rootmnt}/live" || log_warning_msg "Unable to move or bind /live to ${rootmnt}/live"
-
-	# shows cow fs on /overlay for use by live-snapshot
-	mkdir -p "${rootmnt}/live/overlay"
-	mount -o move /live/overlay "${rootmnt}/live/overlay" >/dev/null 2>&1 || mount -o bind /overlay "${rootmnt}/live/overlay" || log_warning_msg "Unable to move or bind /overlay to ${rootmnt}/live/overlay"
-
-}
-
 check_dev ()
 {
 	sysdev="${1}"
diff --git a/scripts/boot/arguments.sh b/scripts/boot/arguments.sh
new file mode 100755
index 0000000..07c9d9a
--- /dev/null
+++ b/scripts/boot/arguments.sh
@@ -0,0 +1,396 @@
+#!/bin/sh
+
+Arguments ()
+{
+	PRESEEDS=""
+	LOCATIONS=""
+
+	for ARGUMENT in $(cat /proc/cmdline)
+	do
+		case "${ARGUMENT}" in
+			skipconfig)
+				NOACCESSIBILITY="Yes"
+				NOFASTBOOT="Yes"
+				NOFSTAB="Yes"
+				NONETWORKING="Yes"
+
+				export NOACCESSIBILITY NOFASTBOOT NOFSTAB NONETWORKING
+				;;
+
+			access=*)
+				ACCESS="${ARGUMENT#access=}"
+				export ACCESS
+				;;
+
+			console=*)
+				DEFCONSOLE="${ARGUMENT#*=}"
+				export DEFCONSOLE
+				;;
+
+			BOOTIF=*)
+				BOOTIF="${x#BOOTIF=}"
+				;;
+
+			debug)
+				DEBUG="Yes"
+				export DEBUG
+
+				set -x
+				;;
+
+			dhcp)
+				# Force dhcp even while netbooting
+				# Use for debugging in case somebody works on fixing dhclient
+				DHCP="Force";
+				export DHCP
+				;;
+
+			nodhcp)
+				unset DHCP
+				;;
+
+			ethdevice=*)
+				DEVICE="${ARGUMENT#ethdevice=}"
+				ETHDEVICE="${DEVICE}"
+				export DEVICE ETHDEVICE
+				;;
+
+			ethdevice-timeout=*)
+				ETHDEV_TIMEOUT="${ARGUMENT#ethdevice-timeout=}"
+				export ETHDEV_TIMEOUT
+				;;
+
+			fetch=*)
+				FETCH="${ARGUMENT#fetch=}"
+				export FETCH
+				;;
+
+			findiso=*)
+				FINDISO="${ARGUMENT#findiso=}"
+				export FINDISO
+				;;
+
+			forcepersistencefsck)
+				FORCEPERSISTENCEFSCK="Yes"
+				export FORCEPERSISTENCEFSCK
+				;;
+
+			ftpfs=*)
+				FTPFS="${ARGUMENT#ftpfs=}"
+				export FTPFS
+				;;
+
+			httpfs=*)
+				HTTPFS="${ARGUMENT#httpfs=}"
+				export HTTPFS
+				;;
+
+			iscsi=*)
+				ISCSI="${ARGUMENT#iscsi=}"
+				#ip:port - separated by ;
+				ISCSI_PORTAL="${ISCSI%;*}"
+				if echo "${ISCSI_PORTAL}" | grep -q , ; then
+					ISCSI_SERVER="${ISCSI_PORTAL%,*}"
+					ISCSI_PORT="${ISCSI_PORTAL#*,}"
+				fi
+				#target name
+				ISCSI_TARGET="${ISCSI#*;}"
+				export ISCSI ISCSI_PORTAL ISCSI_TARGET ISCSI_SERVER ISCSI_PORT
+				;;
+
+			isofrom=*|fromiso=*)
+				FROMISO="${ARGUMENT#*=}"
+				export FROMISO
+				;;
+
+			ignore_uuid)
+				IGNORE_UUID="Yes"
+				export IGNORE_UUID
+				;;
+
+			integrity-check)
+				INTEGRITY_CHECK="Yes"
+				export INTEGRITY_CHECK
+				;;
+
+			ip=*)
+				STATICIP="${ARGUMENT#ip=}"
+
+				if [ -z "${STATICIP}" ]
+				then
+					STATICIP="frommedia"
+				fi
+
+				export STATICIP
+				;;
+
+			live-getty)
+				LIVE_GETTY="1"
+				export LIVE_GETTY
+				;;
+
+			live-media=*|bootfrom=*)
+				LIVE_MEDIA="${ARGUMENT#*=}"
+				export LIVE_MEDIA
+				;;
+
+			live-media-encryption=*|encryption=*)
+				LIVE_MEDIA_ENCRYPTION="${ARGUMENT#*=}"
+				export LIVE_MEDIA_ENCRYPTION
+				;;
+
+			live-media-offset=*)
+				LIVE_MEDIA_OFFSET="${ARGUMENT#live-media-offset=}"
+				export LIVE_MEDIA_OFFSET
+				;;
+
+			live-media-path=*)
+				LIVE_MEDIA_PATH="${ARGUMENT#live-media-path=}"
+				export LIVE_MEDIA_PATH
+				;;
+
+			live-media-timeout=*)
+				LIVE_MEDIA_TIMEOUT="${ARGUMENT#live-media-timeout=}"
+				export LIVE_MEDIA_TIMEOUT
+				;;
+
+			module=*)
+				MODULE="${ARGUMENT#module=}"
+				export MODULE
+				;;
+
+			netboot=*)
+				NETBOOT="${ARGUMENT#netboot=}"
+				export NETBOOT
+				;;
+
+			nfsopts=*)
+				NFSOPTS="${ARGUMENT#nfsopts=}"
+				export NFSOPTS
+				;;
+
+			nfsoverlay=*)
+				NFS_COW="${ARGUMENT#nfsoverlay=}"
+				export NFS_COW
+				;;
+
+			noaccessibility)
+				NOACCESSIBILITY="Yes"
+				export NOACCESSIBILITY
+				;;
+
+			nofastboot)
+				NOFASTBOOT="Yes"
+				export NOFASTBOOT
+				;;
+
+			nofstab)
+				NOFSTAB="Yes"
+				export NOFSTAB
+				;;
+
+			nonetworking)
+				NONETWORKING="Yes"
+				export NONETWORKING
+				;;
+
+			ramdisk-size=*)
+				ramdisk_size="${ARGUMENT#ramdisk-size=}"
+				;;
+
+			swapon)
+				SWAPON="Yes"
+				export SWAPON
+				;;
+
+			persistence)
+				PERSISTENCE="Yes"
+				export PERSISTENCE
+				;;
+
+			persistence-encryption=*)
+				PERSISTENCE_ENCRYPTION="${ARGUMENT#*=}"
+				export PERSISTENCE_ENCRYPTION
+				;;
+
+			persistence-media=*)
+				PERSISTENCE_MEDIA="${ARGUMENT#*=}"
+				export PERSISTENCE_MEDIA
+				;;
+			persistence-method=*)
+				PERSISTENCE_METHOD="${ARGUMENT#*=}"
+				export PERSISTENCE_METHOD
+				;;
+
+			persistence-path=*)
+				PERSISTENCE_PATH="${ARGUMENT#persistence-path=}"
+				export PERSISTENCE_PATH
+				;;
+			persistence-read-only)
+				PERSISTENCE_READONLY="Yes"
+				export PERSISTENCE_READONLY
+				;;
+
+			persistence-storage=*)
+				PERSISTENCE_STORAGE="${ARGUMENT#persistence-storage=}"
+				export PERSISTENCE_STORAGE
+				;;
+
+			persistence-subtext=*)
+				old_root_overlay_label="${old_root_overlay_label}-${ARGUMENT#persistence-subtext=}"
+				old_home_overlay_label="${old_home_overlay_label}-${ARGUMENT#persistence-subtext=}"
+				custom_overlay_label="${custom_overlay_label}-${ARGUMENT#persistence-subtext=}"
+				root_snapshot_label="${root_snapshot_label}-${ARGUMENT#persistence-subtext=}"
+				old_root_snapshot_label="${root_snapshot_label}-${ARGUMENT#persistence-subtext=}"
+				home_snapshot_label="${home_snapshot_label}-${ARGUMENT#persistence-subtext=}"
+				;;
+
+			nopersistence)
+				NOPERSISTENCE="Yes"
+				export NOPERSISTENCE
+				;;
+
+			noprompt)
+				NOPROMPT="Yes"
+				export NOPROMPT
+				;;
+
+			noprompt=*)
+				NOPROMPT="${ARGUMENT#noprompt=}"
+				export NOPROMPT
+				;;
+
+			quickusbmodules)
+				QUICKUSBMODULES="Yes"
+				export QUICKUSBMODULES
+				;;
+
+			preseed/file=*|file=*)
+				LOCATIONS="${ARGUMENT#*=} ${LOCATIONS}"
+				export LOCATIONS
+				;;
+
+			nopreseed)
+				NOPRESEED="Yes"
+				export NOPRESEED
+				;;
+
+			*/*=*)
+				question="${ARGUMENT%%=*}"
+				value="${ARGUMENT#*=}"
+				PRESEEDS="${PRESEEDS}\"${question}=${value}\" "
+				export PRESEEDS
+				;;
+
+			showmounts)
+				SHOWMOUNTS="Yes"
+				export SHOWMOUNTS
+				;;
+
+			silent)
+				SILENT="Yes"
+				export SILENT
+				;;
+
+			todisk=*)
+				TODISK="${ARGUMENT#todisk=}"
+				export TODISK
+				;;
+
+			toram)
+				TORAM="Yes"
+				export TORAM
+				;;
+
+			toram=*)
+				TORAM="Yes"
+				MODULETORAM="${ARGUMENT#toram=}"
+				export TORAM MODULETORAM
+				;;
+
+			exposedroot)
+				EXPOSED_ROOT="Yes"
+				export EXPOSED_ROOT
+				;;
+
+			plainroot)
+				PLAIN_ROOT="Yes"
+				export PLAIN_ROOT
+				;;
+
+			skipunion)
+				SKIP_UNION_MOUNTS="Yes"
+				export SKIP_UNION_MOUNTS
+				;;
+
+			root=*)
+				ROOT="${ARGUMENT#root=}"
+				export ROOT
+				;;
+
+			union=*)
+				UNIONTYPE="${ARGUMENT#union=}"
+				export UNIONTYPE
+				;;
+		esac
+	done
+
+	# sort of compatibility with netboot.h from linux docs
+	if [ -z "${NETBOOT}" ]
+	then
+		if [ "${ROOT}" = "/dev/nfs" ]
+		then
+			NETBOOT="nfs"
+			export NETBOOT
+		elif [ "${ROOT}" = "/dev/cifs" ]
+		then
+			NETBOOT="cifs"
+			export NETBOOT
+		fi
+	fi
+
+	if [ -z "${MODULE}" ]
+	then
+		MODULE="filesystem"
+		export MODULE
+	fi
+
+	if [ -z "${UNIONTYPE}" ]
+	then
+		UNIONTYPE="aufs"
+		export UNIONTYPE
+	fi
+
+	if [ -z "${PERSISTENCE_ENCRYPTION}" ]
+	then
+		PERSISTENCE_ENCRYPTION="none"
+		export PERSISTENCE_ENCRYPTION
+	elif is_in_comma_sep_list luks ${PERSISTENCE_ENCRYPTION}
+	then
+		if ! modprobe dm-crypt
+		then
+			log_warning_msg "Unable to load module dm-crypt"
+			PERSISTENCE_ENCRYPTION=$(echo ${PERSISTENCE_ENCRYPTION} | sed -e 's/\<luks,\|,\?luks$//g')
+			export PERSISTENCE_ENCRYPTION
+		fi
+
+		if [ ! -x /lib/cryptsetup/askpass ] || [ ! -x /sbin/cryptsetup ]
+		then
+			log_warning_msg "cryptsetup in unavailable"
+			PERSISTENCE_ENCRYPTION=$(echo ${PERSISTENCE_ENCRYPTION} | sed -e 's/\<luks,\|,\?luks$//g')
+			export PERSISTENCE_ENCRYPTION
+		fi
+	fi
+
+	if [ -z "${PERSISTENCE_METHOD}" ]
+	then
+		PERSISTENCE_METHOD="snapshot,overlay"
+		export PERSISTENCE_METHOD
+	fi
+
+	if [ -z "${PERSISTENCE_STORAGE}" ]
+	then
+		PERSISTENCE_STORAGE="filesystem,file"
+		export PERSISTENCE_STORAGE
+	fi
+}
diff --git a/scripts/boot/mount-cifs.sh b/scripts/boot/mount-cifs.sh
new file mode 100755
index 0000000..24fef88
--- /dev/null
+++ b/scripts/boot/mount-cifs.sh
@@ -0,0 +1,26 @@
+#!/bin/sh
+
+do_cifsmount ()
+{
+	rc=1
+
+	if [ -x "/sbin/mount.cifs" ]
+	then
+		if [ -z "${NFSOPTS}" ]
+		then
+			CIFSOPTS="-ouser=root,password="
+		else
+			CIFSOPTS="-o ${NFSOPTS}"
+		fi
+
+		log_begin_msg "Trying mount.cifs ${NFSROOT} ${mountpoint} ${CIFSOPTS}"
+		modprobe -q cifs
+
+		if mount.cifs "${NFSROOT}" "${mountpoint}" "${CIFSOPTS}"
+		then
+			rc=0
+		fi
+	fi
+
+	return ${rc}
+}
diff --git a/scripts/boot/mount-http.sh b/scripts/boot/mount-http.sh
new file mode 100755
index 0000000..99851b9
--- /dev/null
+++ b/scripts/boot/mount-http.sh
@@ -0,0 +1,86 @@
+#!/bin/sh
+
+do_httpmount ()
+{
+	rc=1
+
+	for webfile in HTTPFS FTPFS FETCH
+	do
+		local url="$(eval echo \"\$\{${webfile}\}\")"
+		local extension="$(echo "${url}" | sed 's/\(.*\)\.\(.*\)/\2/')"
+
+		if [ -n "$url" ]
+		then
+			case "${extension}" in
+				iso|squashfs|tgz|tar)
+					if [ "${extension}" = "iso" ]
+					then
+						mkdir -p "${alt_mountpoint}"
+						dest="${alt_mountpoint}"
+					else
+						local dest="${mountpoint}/${LIVE_MEDIA_PATH}"
+						mount -t ramfs ram "${mountpoint}"
+						mkdir -p "${dest}"
+					fi
+					if [ "${webfile}" = "FETCH" ]
+					then
+						case "$url" in
+							tftp*)
+								ip="$(dirname $url | sed -e 's|tftp://||g' -e 's|/.*$||g')"
+								rfile="$(echo $url | sed -e "s|tftp://$ip||g")"
+								lfile="$(basename $url)"
+								log_begin_msg "Trying tftp -g -b 10240 -r $rfile -l ${dest}/$lfile $ip"
+								tftp -g -b 10240 -r $rfile -l ${dest}/$lfile $ip
+							;;
+
+							*)
+								log_begin_msg "Trying wget ${url} -O ${dest}/$(basename ${url})"
+								wget "${url}" -O "${dest}/$(basename ${url})"
+								;;
+						esac
+					else
+						log_begin_msg "Trying to mount ${url} on ${dest}/$(basename ${url})"
+						if [ "${webfile}" = "FTPFS" ]
+						then
+							FUSE_MOUNT="curlftpfs"
+							url="$(dirname ${url})"
+						else
+							FUSE_MOUNT="httpfs"
+						fi
+						modprobe fuse
+						$FUSE_MOUNT "${url}" "${dest}"
+						ROOT_PID="$(minips h -C "$FUSE_MOUNT" | { read x y ; echo "$x" ; } )"
+					fi
+					[ ${?} -eq 0 ] && rc=0
+					[ "${extension}" = "tgz" ] && live_dest="ram"
+					if [ "${extension}" = "iso" ]
+					then
+						isoloop=$(setup_loop "${dest}/$(basename "${url}")" "loop" "/sys/block/loop*" "" '')
+						mount -t iso9660 "${isoloop}" "${mountpoint}"
+						rc=${?}
+					fi
+					break
+					;;
+
+				*)
+					log_begin_msg "Unrecognized archive extension for ${url}"
+					;;
+			esac
+		fi
+	done
+
+	if [ ${rc} != 0 ]
+	then
+		if [ -d "${alt_mountpoint}" ]
+		then
+		        umount "${alt_mountpoint}"
+			rmdir "${alt_mountpoint}"
+		fi
+		umount "${mountpoint}"
+	elif [ "${webfile}"  != "FETCH" ] ; then
+		NETBOOT="${webfile}"
+		export NETBOOT
+	fi
+
+	return ${rc}
+}
diff --git a/scripts/boot/mount-iscsi.sh b/scripts/boot/mount-iscsi.sh
new file mode 100755
index 0000000..e9cd9cf
--- /dev/null
+++ b/scripts/boot/mount-iscsi.sh
@@ -0,0 +1,49 @@
+#!/bin/sh
+
+do_iscsi()
+{
+	do_netsetup
+	#modprobe ib_iser
+	modprobe iscsi_tcp
+	local debugopt=""
+	[ "${DEBUG}" = "Yes" ] && debugopt="-d 8"
+	#FIXME this name is supposed to be unique - some date + ifconfig hash?
+	ISCSI_INITIATORNAME="iqn.1993-08.org.debian.live:01:$(echo "${HWADDR}" | sed -e s/://g)"
+	export ISCSI_INITIATORNAME
+	if [ -n "${ISCSI_SERVER}" ] ; then
+		iscsistart $debugopt -i "${ISCSI_INITIATORNAME}" -t "${ISCSI_TARGET}" -g 1 -a "${ISCSI_SERVER}" -p "${ISCSI_PORT}"
+	else
+		iscsistart $debugopt -i "${ISCSI_INITIATORNAME}" -t "${ISCSI_TARGET}" -g 1 -a "${ISCSI_PORTAL}" -p 3260
+	fi
+	if [ $? != 0 ]
+	then
+		panic "Failed to log into iscsi target"
+	fi
+	local host="$(ls -d /sys/class/scsi_host/host*/device/iscsi_host:host* \
+			    /sys/class/scsi_host/host*/device/iscsi_host/host* | sed -e 's:/device.*::' -e 's:.*host::')"
+	if [ -n "${host}" ]
+	then
+		local devices=""
+		local i=0
+		while [ -z "${devices}" -a $i -lt 60 ]
+		do
+			sleep 1
+			devices="$(ls -d /sys/class/scsi_device/${host}*/device/block:* \
+					 /sys/class/scsi_device/${host}*/device/block/* | sed -e 's!.*[:/]!!')"
+			i=$(expr $i + 1)
+			echo -ne $i\\r
+		done
+		for dev in $devices
+		do
+			if check_dev "null" "/dev/$dev"
+			then
+				NETBOOT="iscsi"
+				export NETBOOT
+				return 0;
+			fi
+		done
+		panic "Failed to locate a live device on iSCSI devices (tried: $devices)."
+	else
+		panic "Failed to locate iSCSI host in /sys"
+	fi
+}
diff --git a/scripts/boot/mount-nfs.sh b/scripts/boot/mount-nfs.sh
new file mode 100755
index 0000000..797bfa5
--- /dev/null
+++ b/scripts/boot/mount-nfs.sh
@@ -0,0 +1,26 @@
+#!/bin/sh
+
+do_nfsmount ()
+{
+	rc=1
+
+	modprobe -q nfs
+
+	if [ -n "${NFSOPTS}" ]
+	then
+		NFSOPTS="-o ${NFSOPTS}"
+	fi
+
+	log_begin_msg "Trying nfsmount -o nolock -o ro ${NFSOPTS} ${NFSROOT} ${mountpoint}"
+
+	# FIXME: This while loop is an ugly HACK round an nfs bug
+	i=0
+	while [ "$i" -lt 60 ]
+	do
+		nfsmount -o nolock -o ro ${NFSOPTS} "${NFSROOT}" "${mountpoint}" && rc=0 && break
+		sleep 1
+		i="$(($i + 1))"
+	done
+
+	return ${rc}
+}
diff --git a/scripts/boot/netboot.sh b/scripts/boot/netboot.sh
new file mode 100755
index 0000000..763a258
--- /dev/null
+++ b/scripts/boot/netboot.sh
@@ -0,0 +1,39 @@
+#!/bin/sh
+
+do_netmount()
+{
+	do_netsetup
+
+	if [ "${NFSROOT}" = "auto" ]
+	then
+		NFSROOT=${ROOTSERVER}:${ROOTPATH}
+	fi
+
+	rc=1
+
+	if ( [ -n "${FETCH}" ] || [ -n "${HTTPFS}" ] || [ -n "${FTPFS}" ] )
+	then
+		do_httpmount
+		return $?
+	fi
+
+	if [ "${NFSROOT#*:}" = "${NFSROOT}" ] && [ "$NETBOOT" != "cifs" ]
+	then
+		NFSROOT=${ROOTSERVER}:${NFSROOT}
+	fi
+
+	log_begin_msg "Trying netboot from ${NFSROOT}"
+
+	if [ "${NETBOOT}" != "nfs" ] && do_cifsmount
+	then
+		rc=0
+	elif do_nfsmount
+	then
+		NETBOOT="nfs"
+		export NETBOOT
+		rc=0
+	fi
+
+	log_end_msg
+	return ${rc}
+}
diff --git a/scripts/boot/networking.sh b/scripts/boot/networking.sh
new file mode 100755
index 0000000..268770e
--- /dev/null
+++ b/scripts/boot/networking.sh
@@ -0,0 +1,157 @@
+#!/bin/sh
+
+do_netsetup ()
+{
+	modprobe -q af_packet # For DHCP
+
+	udevadm trigger
+	udevadm settle
+
+	[ -n "$ETHDEV_TIMEOUT" ] || ETHDEV_TIMEOUT=15
+	echo "Using timeout of $ETHDEV_TIMEOUT seconds for network configuration."
+
+	if [ -z "${NETBOOT}" ] && [ -z "${FETCH}" ] && \
+	   [ -z "${HTTPFS}" ] && [ -z "${FTPFS}" ]
+	then
+
+
+	# support for Syslinux IPAPPEND parameter
+	# it sets the BOOTIF variable on the kernel parameter
+
+	if [ -n "${BOOTIF}" ]
+	then
+		# pxelinux sets BOOTIF to a value based on the mac address of the
+		# network card used to PXE boot, so use this value for DEVICE rather
+		# than a hard-coded device name from initramfs.conf. this facilitates
+		# network booting when machines may have multiple network cards.
+		# pxelinux sets BOOTIF to 01-$mac_address
+
+		# strip off the leading "01-", which isn't part of the mac
+		# address
+		temp_mac=${BOOTIF#*-}
+
+		# convert to typical mac address format by replacing "-" with ":"
+		bootif_mac=""
+		IFS='-'
+		for x in $temp_mac
+		do
+			if [ -z "$bootif_mac" ]
+			then
+				bootif_mac="$x"
+			else
+				bootif_mac="$bootif_mac:$x"
+			fi
+		done
+		unset IFS
+
+		# look for devices with matching mac address, and set DEVICE to
+		# appropriate value if match is found.
+
+		for device in /sys/class/net/*
+		do
+			if [ -f "$device/address" ]
+			then
+				current_mac=$(cat "$device/address")
+
+				if [ "$bootif_mac" = "$current_mac" ]
+				then
+					DEVICE=${device##*/}
+					break
+				fi
+			fi
+		done
+	fi
+
+	# if ethdevice was not specified on the kernel command line
+	# make sure we try to get a working network configuration
+	# for *every* present network device (except for loopback of course)
+	if [ -z "$ETHDEVICE" ] ; then
+		echo "If you want to boot from a specific device use bootoption ethdevice=..."
+		for device in /sys/class/net/*; do
+			dev=${device##*/} ;
+			if [ "$dev" != "lo" ] ; then
+				ETHDEVICE="$ETHDEVICE $dev"
+			fi
+		done
+	fi
+
+	# split args of ethdevice=eth0,eth1 into "eth0 eth1"
+	for device in $(echo $ETHDEVICE | sed 's/,/ /g') ; do
+		devlist="$devlist $device"
+	done
+
+	# this is tricky (and ugly) because ipconfig sometimes just hangs/runs into
+	# an endless loop; if execution fails give it two further tries, that's
+	# why we use '$devlist $devlist $devlist' for the other for loop
+	for dev in $devlist $devlist $devlist ; do
+		echo "Executing ipconfig -t $ETHDEV_TIMEOUT $dev"
+		ipconfig -t "$ETHDEV_TIMEOUT" $dev | tee -a /netboot.config &
+		jobid=$!
+		sleep "$ETHDEV_TIMEOUT" ; sleep 1
+		if [ -r /proc/"$jobid"/status ] ; then
+			echo "Killing job $jobid for device $dev as ipconfig ran into recursion..."
+			kill -9 $jobid
+		fi
+
+		# if configuration of device worked we should have an assigned
+		# IP address, if so let's use the device as $DEVICE for later usage.
+		# simple and primitive approach which seems to work fine
+		if ifconfig $dev | grep -q 'inet.*addr:' ; then
+			export DEVICE="$dev"
+			break
+		fi
+	done
+
+	else
+		for interface in ${DEVICE}; do
+			ipconfig -t "$ETHDEV_TIMEOUT" ${interface} | tee /netboot-${interface}.config
+			[ -e /tmp/net-${interface}.conf ] && . /tmp/net-${interface}.conf
+			if [ "$IPV4ADDR" != "0.0.0.0" ]
+			then
+				break
+			fi
+		done
+	fi
+
+	for interface in ${DEVICE}; do
+		# source relevant ipconfig output
+		OLDHOSTNAME=${HOSTNAME}
+		[ -e /tmp/net-${interface}.conf ] && . /tmp/net-${interface}.conf
+		[ -z ${HOSTNAME} ] && HOSTNAME=${OLDHOSTNAME}
+		export HOSTNAME
+
+		if [ -n "${interface}" ]
+		then
+			HWADDR="$(cat /sys/class/net/${interface}/address)"
+		fi
+
+		if [ ! -e "/etc/resolv.conf" ]
+		then
+			echo "Creating /etc/resolv.conf"
+
+			if [ -n "${DNSDOMAIN}" ]
+			then
+				echo "domain ${DNSDOMAIN}" > /etc/resolv.conf
+				echo "search ${DNSDOMAIN}" >> /etc/resolv.conf
+			fi
+
+			for i in ${IPV4DNS0} ${IPV4DNS1} ${IPV4DNS1}
+			do
+				if [ -n "$i" ] && [ "$i" != 0.0.0.0 ]
+				then
+					echo "nameserver $i" >> /etc/resolv.conf
+				fi
+			done
+		fi
+
+		# Check if we have a network device at all
+		if ! ls /sys/class/net/"$interface" > /dev/null 2>&1 && \
+		   ! ls /sys/class/net/eth0 > /dev/null 2>&1 && \
+		   ! ls /sys/class/net/wlan0 > /dev/null 2>&1 && \
+		   ! ls /sys/class/net/ath0 > /dev/null 2>&1 && \
+		   ! ls /sys/class/net/ra0 > /dev/null 2>&1
+		then
+			panic "No supported network device found, maybe a non-mainline driver is required."
+		fi
+	done
+}
diff --git a/scripts/boot/overlay.sh b/scripts/boot/overlay.sh
new file mode 100755
index 0000000..193c510
--- /dev/null
+++ b/scripts/boot/overlay.sh
@@ -0,0 +1,424 @@
+#!/bin/sh
+
+setup_unionfs ()
+{
+	image_directory="${1}"
+	rootmnt="${2}"
+	addimage_directory="${3}"
+
+	case ${UNIONTYPE} in
+		aufs|unionfs|overlayfs)
+			modprobe -q -b ${UNIONTYPE}
+
+			if ! cut -f2 /proc/filesystems | grep -q "^${UNIONTYPE}\$" && [ -x /bin/unionfs-fuse ]
+			then
+				echo "${UNIONTYPE} not available, falling back to unionfs-fuse."
+				echo "This might be really slow."
+
+				UNIONTYPE="unionfs-fuse"
+			fi
+			;;
+	esac
+
+	if [ "${UNIONTYPE}" = unionfs-fuse ]
+	then
+		modprobe fuse
+	fi
+
+	# run-init can't deal with images in a subdir, but we're going to
+	# move all of these away before it runs anyway.  No, we're not,
+	# put them in / since move-mounting them into / breaks mono and
+	# some other apps.
+
+	croot="/"
+
+	# Let's just mount the read-only file systems first
+	rofslist=""
+
+	if [ -z "${PLAIN_ROOT}" ]
+	then
+		# Read image names from ${MODULE}.module if it exists
+		if [ -e "${image_directory}/filesystem.${MODULE}.module" ]
+		then
+			for IMAGE in $(cat ${image_directory}/filesystem.${MODULE}.module)
+			do
+				image_string="${image_string} ${image_directory}/${IMAGE}"
+			done
+		elif [ -e "${image_directory}/${MODULE}.module" ]
+		then
+			for IMAGE in $(cat ${image_directory}/${MODULE}.module)
+			do
+				image_string="${image_string} ${image_directory}/${IMAGE}"
+			done
+		else
+			# ${MODULE}.module does not exist, create a list of images
+			for FILESYSTEM in squashfs ext2 ext3 ext4 xfs jffs2 dir
+			do
+				for IMAGE in "${image_directory}"/*."${FILESYSTEM}"
+				do
+					if [ -e "${IMAGE}" ]
+					then
+						image_string="${image_string} ${IMAGE}"
+					fi
+				done
+			done
+
+			if [ -n "${addimage_directory}" ] && [ -d "${addimage_directory}" ]
+			then
+				for FILESYSTEM in squashfs ext2 ext3 ext4 xfs jffs2 dir
+				do
+					for IMAGE in "${addimage_directory}"/*."${FILESYSTEM}"
+					do
+						if [ -e "${IMAGE}" ]
+						then
+							image_string="${image_string} ${IMAGE}"
+						fi
+					done
+				done
+			fi
+
+			# Now sort the list
+			image_string="$(echo ${image_string} | sed -e 's/ /\n/g' | sort )"
+		fi
+
+		[ -n "${MODULETORAMFILE}" ] && image_string="${image_directory}/$(basename ${MODULETORAMFILE})"
+
+		mkdir -p "${croot}"
+
+		for image in ${image_string}
+		do
+			imagename=$(basename "${image}")
+
+			export image devname
+			maybe_break live-realpremount
+			log_begin_msg "Running /scripts/live-realpremount"
+			run_scripts /scripts/live-realpremount
+			log_end_msg
+
+			if [ -d "${image}" ]
+			then
+				# it is a plain directory: do nothing
+				rofslist="${image} ${rofslist}"
+			elif [ -f "${image}" ]
+			then
+				if losetup --help 2>&1 | grep -q -- "-r\b"
+				then
+					backdev=$(get_backing_device "${image}" "-r")
+				else
+					backdev=$(get_backing_device "${image}")
+				fi
+				fstype=$(get_fstype "${backdev}")
+
+				if [ "${fstype}" = "unknown" ]
+				then
+					panic "Unknown file system type on ${backdev} (${image})"
+				fi
+
+				if [ -z "${fstype}" ]
+				then
+					fstype="${imagename##*.}"
+					log_warning_msg "Unknown file system type on ${backdev} (${image}), assuming ${fstype}."
+				fi
+
+				if [ "${UNIONTYPE}" != "unionmount" ]
+				then
+					mpoint="${croot}/${imagename}"
+					rofslist="${mpoint} ${rofslist}"
+				else
+					mpoint="${rootmnt}"
+					rofslist="${rootmnt} ${rofslist}"
+				fi
+				mkdir -p "${mpoint}"
+				log_begin_msg "Mounting \"${image}\" on \"${mpoint}\" via \"${backdev}\""
+				mount -t "${fstype}" -o ro,noatime "${backdev}" "${mpoint}" || panic "Can not mount ${backdev} (${image}) on ${mpoint}"
+				log_end_msg
+			fi
+		done
+	else
+		# we have a plain root system
+		mkdir -p "${croot}/filesystem"
+		log_begin_msg "Mounting \"${image_directory}\" on \"${croot}/filesystem\""
+		mount -t $(get_fstype "${image_directory}") -o ro,noatime "${image_directory}" "${croot}/filesystem" || \
+			panic "Can not mount ${image_directory} on ${croot}/filesystem" && \
+			rofslist="${croot}/filesystem ${rofslist}"
+		# probably broken:
+		mount -o bind ${croot}/filesystem $mountpoint
+		log_end_msg
+	fi
+
+	# tmpfs file systems
+	touch /etc/fstab
+	mkdir -p /live
+	mount -t tmpfs tmpfs /live
+	mkdir -p /live/overlay
+
+	# Looking for persistence devices or files
+	if [ -n "${PERSISTENCE}" ] && [ -z "${NOPERSISTENCE}" ]
+	then
+
+		if [ -z "${QUICKUSBMODULES}" ]
+		then
+			# Load USB modules
+			num_block=$(ls -l /sys/block | wc -l)
+			for module in sd_mod uhci-hcd ehci-hcd ohci-hcd usb-storage
+			do
+				modprobe -q -b ${module}
+			done
+
+			udevadm trigger
+			udevadm settle
+
+			# For some reason, udevsettle does not block in this scenario,
+			# so we sleep for a little while.
+			#
+			# See https://bugs.launchpad.net/ubuntu/+source/casper/+bug/84591
+			for timeout in 5 4 3 2 1
+			do
+				sleep 1
+
+				if [ $(ls -l /sys/block | wc -l) -gt ${num_block} ]
+				then
+					break
+				fi
+			done
+		fi
+
+		case "${PERSISTENCE_MEDIA}" in
+			removable)
+				whitelistdev="$(removable_dev)"
+				;;
+			removable-usb)
+				whitelistdev="$(removable_usb_dev)"
+				;;
+			*)
+				whitelistdev=""
+				;;
+		esac
+
+		if is_in_comma_sep_list overlay ${PERSISTENCE_METHOD}
+		then
+			overlays="${old_root_overlay_label} ${old_home_overlay_label} ${custom_overlay_label}"
+		fi
+
+		if is_in_comma_sep_list snapshot ${PERSISTENCE_METHOD}
+		then
+			snapshots="${root_snapshot_label} ${home_snapshot_label}"
+		fi
+
+		local root_snapdata=""
+		local home_snapdata=""
+		local overlay_devices=""
+		for media in $(find_persistence_media "${overlays}" "${snapshots}" "${whitelistdev}")
+		do
+			media="$(echo ${media} | tr ":" " ")"
+			case ${media} in
+				${root_snapshot_label}=*|${old_root_snapshot_label}=*)
+					if [ -z "${root_snapdata}" ]
+					then
+						root_snapdata="${media#*=}"
+					fi
+					;;
+				${home_snapshot_label}=*)
+					# This second type should be removed when snapshot will get smarter,
+					# hence when "/etc/live-snapshot*list" will be supported also by
+					# ext2|ext3|ext4|jffs2 snapshot types.
+					if [ -z "${home_snapdata}" ]
+					then
+						home_snapdata="${media#*=}"
+					fi
+					;;
+				${old_root_overlay_label}=*)
+					device="${media#*=}"
+					fix_backwards_compatibility ${device} / union
+					overlay_devices="${overlay_devices} ${device}"
+					;;
+				${old_home_overlay_label}=*)
+					device="${media#*=}"
+					fix_backwards_compatibility ${device} /home bind
+					overlay_devices="${overlay_devices} ${device}"
+					;;
+				${custom_overlay_label}=*)
+					device="${media#*=}"
+					overlay_devices="${overlay_devices} ${device}"
+					;;
+			 esac
+		done
+	elif [ -n "${NFS_COW}" ] && [ -z "${NOPERSISTENCE}" ]
+	then
+		# check if there are any nfs options
+		if echo ${NFS_COW}|grep -q ','
+		then
+			nfs_cow_opts="-o nolock,$(echo ${NFS_COW}|cut -d, -f2-)"
+			nfs_cow=$(echo ${NFS_COW}|cut -d, -f1)
+		else
+			nfs_cow_opts="-o nolock"
+			nfs_cow=${NFS_COW}
+		fi
+
+		if [ -n "${PERSISTENCE_READONLY}" ]
+		then
+			nfs_cow_opts="${nfs_cow_opts},nocto,ro"
+		fi
+
+		mac="$(get_mac)"
+		if [ -n "${mac}" ]
+		then
+			cowdevice=$(echo ${nfs_cow}|sed "s/client_mac_address/${mac}/")
+			cow_fstype="nfs"
+		else
+			panic "unable to determine mac address"
+		fi
+	fi
+
+	if [ -z "${cowdevice}" ]
+	then
+		cowdevice="tmpfs"
+		cow_fstype="tmpfs"
+		cow_mountopt="rw,noatime,mode=755"
+	fi
+
+	if [ "${UNIONTYPE}" != "unionmount" ]
+	then
+		if [ -n "${PERSISTENCE_READONLY}" ] && [ "${cowdevice}" != "tmpfs" ]
+		then
+			mount -t tmpfs -o rw,noatime,mode=755 tmpfs "/live/overlay"
+			root_backing="/live/persistence/$(basename ${cowdevice})-root"
+			mkdir -p ${root_backing}
+		else
+			root_backing="/live/overlay"
+		fi
+
+		if [ "${cow_fstype}" = "nfs" ]
+		then
+			log_begin_msg \
+				"Trying nfsmount ${nfs_cow_opts} ${cowdevice} ${root_backing}"
+			nfsmount ${nfs_cow_opts} ${cowdevice} ${root_backing} || \
+				panic "Can not mount ${cowdevice} (n: ${cow_fstype}) on ${root_backing}"
+		else
+			mount -t ${cow_fstype} -o ${cow_mountopt} ${cowdevice} ${root_backing} || \
+				panic "Can not mount ${cowdevice} (o: ${cow_fstype}) on ${root_backing}"
+		fi
+	fi
+
+	rofscount=$(echo ${rofslist} |wc -w)
+
+	rofs=${rofslist%% }
+
+	if [ -n "${EXPOSED_ROOT}" ]
+	then
+		if [ ${rofscount} -ne 1 ]
+		then
+			panic "only one RO file system supported with exposedroot: ${rofslist}"
+		fi
+
+		mount --bind ${rofs} ${rootmnt} || \
+			panic "bind mount of ${rofs} failed"
+
+		if [ -z "${SKIP_UNION_MOUNTS}" ]
+		then
+			cow_dirs='/var/tmp /var/lock /var/run /var/log /var/spool /home /var/lib/live'
+		else
+			cow_dirs=''
+		fi
+	else
+		cow_dirs="/"
+	fi
+
+	if [ "${cow_fstype}" != "tmpfs" ] && [ "${cow_dirs}" != "/" ] && [ "${UNIONTYPE}" = "unionmount" ]
+	then
+		true # FIXME: Maybe it does, I don't really know.
+		#panic "unionmount does not support subunions (${cow_dirs})."
+	fi
+
+	for dir in ${cow_dirs}; do
+		unionmountpoint="${rootmnt}${dir}"
+		mkdir -p ${unionmountpoint}
+		if [ "${UNIONTYPE}" = "unionmount" ]
+		then
+			# FIXME: handle PERSISTENCE_READONLY
+			unionmountopts="-t ${cow_fstype} -o noatime,union,${cow_mountopt} ${cowdevice}"
+			mount_full $unionmountopts "${unionmountpoint}"
+		else
+			cow_dir="/live/overlay${dir}"
+			rofs_dir="${rofs}${dir}"
+			mkdir -p ${cow_dir}
+			if [ -n "${PERSISTENCE_READONLY}" ] && [ "${cowdevice}" != "tmpfs" ]
+			then
+				do_union ${unionmountpoint} ${cow_dir} ${root_backing} ${rofs_dir}
+			else
+				do_union ${unionmountpoint} ${cow_dir} ${rofs_dir}
+			fi
+		fi || panic "mount ${UNIONTYPE} on ${unionmountpoint} failed with option ${unionmountopts}"
+	done
+
+	# Correct the permissions of /:
+	chmod 0755 "${rootmnt}"
+
+	live_rofs_list=""
+	# SHOWMOUNTS is necessary for custom mounts with the union option
+	# Since we may want to do custom mounts in user-space it's best to always enable SHOWMOUNTS
+	if true #[ -n "${SHOWMOUNTS}" ] || ( [ -n "${PERSISTENCE}" ] && [ -z "${NOPERSISTENCE}" ] 1)
+	then
+		# XXX: is the for loop really necessary? rofslist can only contain one item (see above XXX about EXPOSEDROOT) and this is also assumed elsewhere above (see use of $rofs above).
+		for d in ${rofslist}
+		do
+			live_rofs="/live/rofs/${d##*/}"
+			live_rofs_list="${live_rofs_list} ${live_rofs}"
+			mkdir -p "${live_rofs}"
+			case d in
+				*.dir)
+					# do nothing # mount -o bind "${d}" "${live_rofs}"
+					;;
+				*)
+					case "${UNIONTYPE}" in
+						unionfs-fuse)
+							mount -o bind "${d}" "${live_rofs}"
+							;;
+						*)
+							mount -o move "${d}" "${live_rofs}"
+							;;
+					esac
+					;;
+			esac
+		done
+	fi
+
+	# Adding custom persistence
+	if [ -n "${PERSISTENCE}" ] && [ -z "${NOPERSISTENCE}" ]
+	then
+		local custom_mounts="/tmp/custom_mounts.list"
+		rm -rf ${custom_mounts} 2> /dev/null
+
+		# Gather information about custom mounts from devies detected as overlays
+		get_custom_mounts ${custom_mounts} ${overlay_devices}
+
+		[ -n "${DEBUG}" ] && cp ${custom_mounts} "/live/persistence"
+
+		# Now we do the actual mounting (and symlinking)
+		local used_overlays=""
+		used_overlays=$(activate_custom_mounts ${custom_mounts})
+		rm ${custom_mounts}
+
+		# Close unused overlays (e.g. due to missing $persistence_list)
+		for overlay in ${overlay_devices}
+		do
+			if echo ${used_overlays} | grep -qve "^\(.* \)\?${device}\( .*\)\?$"
+			then
+				close_persistence_media ${overlay}
+			fi
+		done
+
+		# Look for other snapshots to copy in
+		[ -n "${root_snapdata}" ] && try_snap "${root_snapdata}" "${rootmnt}" "ROOT"
+		# This second type should be removed when snapshot grow smarter
+		[ -n "${home_snapdata}" ] && try_snap "${home_snapdata}" "${rootmnt}" "HOME" "/home"
+	fi
+
+	mkdir -p "${rootmnt}/live"
+	mount -o move /live "${rootmnt}/live" >/dev/null 2>&1 || mount -o bind /live "${rootmnt}/live" || log_warning_msg "Unable to move or bind /live to ${rootmnt}/live"
+
+	# shows cow fs on /overlay for use by live-snapshot
+	mkdir -p "${rootmnt}/live/overlay"
+	mount -o move /live/overlay "${rootmnt}/live/overlay" >/dev/null 2>&1 || mount -o bind /overlay "${rootmnt}/live/overlay" || log_warning_msg "Unable to move or bind /overlay to ${rootmnt}/live/overlay"
+
+}
diff --git a/scripts/boot/snapshot.sh b/scripts/boot/snapshot.sh
new file mode 100755
index 0000000..3c9ebcd
--- /dev/null
+++ b/scripts/boot/snapshot.sh
@@ -0,0 +1,171 @@
+#!/bin/sh
+
+do_snap_copy ()
+{
+	fromdev="${1}"
+	todir="${2}"
+	snap_type="${3}"
+	size=$(fs_size "${fromdev}" "" "used")
+
+	if [ -b "${fromdev}" ]
+	then
+		log_success_msg "Copying snapshot ${fromdev} to ${todir}..."
+
+		# look for free mem
+		if [ -n "${HOMEMOUNTED}" -a "${snap_type}" = "HOME" ]
+		then
+			todev=$(awk -v pat="$(base_path ${todir})" '$2 == pat { print $1 }' /proc/mounts)
+			freespace=$(df -k | awk '/'${todev}'/{print $4}')
+		else
+			freespace=$(awk '/^MemFree:/{f=$2} /^Cached:/{c=$2} END{print f+c}' /proc/meminfo)
+		fi
+
+		tomount="/mnt/tmpsnap"
+
+		if [ ! -d "${tomount}" ]
+		then
+			mkdir -p "${tomount}"
+		fi
+
+		fstype=$(get_fstype "${fromdev}")
+
+		if [ -n "${fstype}" ]
+		then
+			# Copying stuff...
+			mount -o ro -t "${fstype}" "${fromdev}" "${tomount}" || log_warning_msg "Error in mount -t ${fstype} -o ro ${fromdev} ${tomount}"
+			cp -a "${tomount}"/* ${todir}
+			umount "${tomount}"
+		else
+			log_warning_msg "Unrecognized fstype: ${fstype} on ${fromdev}:${snap_type}"
+		fi
+
+		rmdir "${tomount}"
+
+		if echo ${fromdev} | grep -qs loop
+		then
+			losetup -d "${fromdev}"
+		fi
+
+		return 0
+	else
+		log_warning_msg "Unable to find the snapshot ${snap_type} medium"
+		return 1
+	fi
+}
+
+try_snap ()
+{
+	# copy the contents of previously found snapshot to ${snap_mount}
+	# and remember the device and filename for resync on exit in live-boot.init
+
+	snapdata="${1}"
+	snap_mount="${2}"
+	snap_type="${3}"
+	snap_relpath="${4}"
+
+	if [ -z "${snap_relpath}" ]
+	then
+		# root snapshot, default usage
+		snap_relpath="/"
+	else
+		# relative snapshot (actually used just for "/home" snapshots)
+		snap_mount="${2}${snap_relpath}"
+	fi
+
+	if [ -n "${snapdata}" ] && [ ! -b "${snapdata}" ]
+	then
+		log_success_msg "found snapshot: ${snapdata}"
+		snapdev="$(echo ${snapdata} | cut -f1 -d ' ')"
+		snapback="$(echo ${snapdata} | cut -f2 -d ' ')"
+		snapfile="$(echo ${snapdata} | cut -f3 -d ' ')"
+
+		if ! try_mount "${snapdev}" "${snapback}" "ro"
+		then
+			break
+		fi
+
+		RES="0"
+
+		if echo "${snapfile}" | grep -qs '\(squashfs\|ext2\|ext3\|ext4\|jffs2\)'
+		then
+			# squashfs, jffs2 or ext2/ext3/ext4 snapshot
+			dev=$(get_backing_device "${snapback}/${snapfile}")
+
+			do_snap_copy "${dev}" "${snap_mount}" "${snap_type}"
+			RES="$?"
+		else
+			# cpio.gz snapshot
+
+			# Unfortunately klibc's cpio is incompatible with the
+			# rest of the world; everything else requires -u -d,
+			# while klibc doesn't implement them. Try to detect
+			# whether it's in use.
+			cpiopath="$(which cpio)" || true
+			if [ "$cpiopath" ] && grep -aq /lib/klibc "$cpiopath"
+			then
+				cpioargs=
+			else
+				cpioargs='--unconditional --make-directories'
+			fi
+
+			if [ -s "${snapback}/${snapfile}" ]
+			then
+				BEFOREDIR="$(pwd)"
+				cd "${snap_mount}" && zcat "${snapback}/${snapfile}" | $cpiopath $cpioargs --extract --preserve-modification-time --no-absolute-filenames --sparse 2>/dev/null
+				RES="$?"
+				cd "${BEFOREDIR}"
+			else
+				log_warning_msg "${snapback}/${snapfile} is empty, adding it for sync on reboot."
+				RES="0"
+			fi
+
+			if [ "${RES}" != "0" ]
+			then
+				log_warning_msg "failure to \"zcat ${snapback}/${snapfile} | $cpiopath $cpioargs --extract --preserve-modification-time --no-absolute-filenames --sparse\""
+			fi
+		fi
+
+		umount "${snapback}" ||  log_warning_msg "failure to \"umount ${snapback}\""
+
+		if [ "${RES}" != "0" ]
+		then
+			log_warning_msg "Impossible to include the ${snapfile} Snapshot file"
+		fi
+
+	elif [ -b "${snapdata}" ]
+	then
+		# Try to find if it could be a snapshot partition
+		dev="${snapdata}"
+		log_success_msg "found snapshot ${snap_type} device on ${dev}"
+		if echo "${dev}" | grep -qs loop
+		then
+			# strange things happens, user confused?
+			snaploop=$( losetup ${dev} | awk '{print $3}' | tr -d '()' )
+			snapfile=$(basename ${snaploop})
+			snapdev=$(awk -v pat="$( dirname ${snaploop})" '$2 == pat { print $1 }' /proc/mounts)
+		else
+			snapdev="${dev}"
+		fi
+
+		if ! do_snap_copy "${dev}" "${snap_mount}" "${snap_type}"
+		then
+			log_warning_msg "Impossible to include the ${snap_type} Snapshot (i)"
+			return 1
+		else
+			if [ -n "${snapfile}" ]
+			then
+				# it was a loop device, user confused
+				umount ${snapdev}
+			fi
+		fi
+	else
+		log_warning_msg "Impossible to include the ${snap_type} Snapshot (o)"
+		return 1
+	fi
+
+	if [ -z ${PERSISTENCE_READONLY} ]
+	then
+		echo "export ${snap_type}SNAP=${snap_relpath}:${snapdev}:${snapfile}" >> snapshot.conf # for resync on reboot/halt
+	fi
+	return 0
+}
diff --git a/scripts/boot/toram-todisk.sh b/scripts/boot/toram-todisk.sh
new file mode 100755
index 0000000..6164dee
--- /dev/null
+++ b/scripts/boot/toram-todisk.sh
@@ -0,0 +1,102 @@
+#!/bin/sh
+
+copy_live_to ()
+{
+	copyfrom="${1}"
+	copytodev="${2}"
+	copyto="${copyfrom}_swap"
+
+	if [ -z "${MODULETORAM}" ]
+	then
+		size=$(fs_size "" ${copyfrom}/${LIVE_MEDIA_PATH} "used")
+	else
+		MODULETORAMFILE="${copyfrom}/${LIVE_MEDIA_PATH}/${MODULETORAM}"
+
+		if [ -f "${MODULETORAMFILE}" ]
+		then
+			size=$( expr $(ls -la ${MODULETORAMFILE} | awk '{print $5}') / 1024 + 5000 )
+		else
+			log_warning_msg "Error: toram-module ${MODULETORAM} (${MODULETORAMFILE}) could not be read."
+			return 1
+		fi
+	fi
+
+	if [ "${copytodev}" = "ram" ]
+	then
+		# copying to ram:
+		freespace=$(awk '/^MemFree:/{f=$2} /^Cached:/{c=$2} END{print f+c}' /proc/meminfo)
+		mount_options="-o size=${size}k"
+		free_string="memory"
+		fstype="tmpfs"
+		dev="/dev/shm"
+	else
+		# it should be a writable block device
+		if [ -b "${copytodev}" ]
+		then
+			dev="${copytodev}"
+			free_string="space"
+			fstype=$(get_fstype "${dev}")
+			freespace=$(fs_size "${dev}")
+		else
+			log_warning_msg "${copytodev} is not a block device."
+			return 1
+		fi
+	fi
+
+	if [ "${freespace}" -lt "${size}" ]
+	then
+		log_warning_msg "Not enough free ${free_string} (${freespace}k free, ${size}k needed) to copy live media in ${copytodev}."
+		return 1
+	fi
+
+	# Custom ramdisk size
+	if [ -z "${mount_options}" ] && [ -n "${ramdisk_size}" ]
+	then
+		# FIXME: should check for wrong values
+		mount_options="-o size=${ramdisk_size}"
+	fi
+
+	# begin copying (or uncompressing)
+	mkdir "${copyto}"
+	log_begin_msg "mount -t ${fstype} ${mount_options} ${dev} ${copyto}"
+	mount -t "${fstype}" ${mount_options} "${dev}" "${copyto}"
+
+	if [ "${extension}" = "tgz" ]
+	then
+		cd "${copyto}"
+		tar zxf "${copyfrom}/${LIVE_MEDIA_PATH}/$(basename ${FETCH})"
+		rm -f "${copyfrom}/${LIVE_MEDIA_PATH}/$(basename ${FETCH})"
+		mount -r -o move "${copyto}" "${rootmnt}"
+		cd "${OLDPWD}"
+	else
+		if [ -n "${MODULETORAMFILE}" ]
+		then
+			if [ -x /bin/rsync ]
+			then
+				echo " * Copying $MODULETORAMFILE to RAM" 1>/dev/console
+				rsync -a --progress ${MODULETORAMFILE} ${copyto} 1>/dev/console # copy only the filesystem module
+			else
+				cp ${MODULETORAMFILE} ${copyto} # copy only the filesystem module
+			fi
+		else
+			if [ -x /bin/rsync ]
+			then
+				echo " * Copying whole medium to RAM" 1>/dev/console
+				rsync -a --progress ${copyfrom}/* ${copyto} 1>/dev/console  # "cp -a" from busybox also copies hidden files
+			else
+				mkdir -p ${copyto}/${LIVE_MEDIA_PATH}
+				cp -a ${copyfrom}/${LIVE_MEDIA_PATH}/* ${copyto}/${LIVE_MEDIA_PATH}
+				if [ -e ${copyfrom}/${LIVE_MEDIA_PATH}/.disk ]
+				then
+					cp -a ${copyfrom}/${LIVE_MEDIA_PATH}/.disk ${copyto}
+				fi
+			fi
+		fi
+
+		umount ${copyfrom}
+		mount -r -o move ${copyto} ${copyfrom}
+	fi
+
+	rmdir ${copyto}
+	return 0
+}

-- 
live-boot



More information about the debian-live-changes mailing list